inherited InputSymbolsForm: TInputSymbolsForm
  Left = 298
  Top = 84
  Width = 626
  Height = 499
  Caption = 'Saltmod input symbols'
  OldCreateOrder = True
  PixelsPerInch = 96
  TextHeight = 16
  inherited StatusBar1: TStatusBar
    Top = 445
    Width = 618
  end
  object InputSymbolsMemo: TMemo
    Left = 16
    Top = 16
    Width = 585
    Height = 385
    Lines.Strings = (
      ''
      '                                 LIST OF SYMBOLS OF INPUT DATA'
      ''
      'A'#9'Fraction of total area occupied by irrigated group A crops (-)'
      'B'#9'Fraction of total area occupied by irrigated group B crops (-)'
      'Cic'#9'Salt concentration of the incoming canal water (EC in dS/m)'
      
        'CA0'#9'Initial salt concentration of the soil moisture, at field sa' +
        'turation, in the root '
      
        '              zone of the irrigated land under group A crop(s) (' +
        'EC in dS/m)'
      
        'CB0'#9'Initial salt concentration of the soil moisture, at field sa' +
        'turation, in the root '
      
        '              zone of the irrigated land under group B crop(s) (' +
        'EC in dS/m)'
      
        'CB0         Initial salt concentration of the soil moisture, at ' +
        'field saturation, in the root'
      
        '              zone of the irrigated land under group B crop(s) (' +
        'EC in dS/m)'
      'Ch'#9'Salt concentration of the incoming ground water (EC in dS/m)'
      'Cp'#9'Salt concentration of the rain water (EC in dS/m)'
      
        'Cq0'#9'Initial salt concentration of the ground water in the aquife' +
        'r (EC in dS/m)'
      
        'Cx0'#9'Initial salt concentration of the soil moisture in the trans' +
        'ition zone (EC in dS/m)'
      
        'Cxa0'#9'Initial salt concentration of the ground water in the upper' +
        ' part of the transition '
      '              zone, i.e. above drain level (EC in dS/m)'
      
        'Cxb0'#9'Initial salt concentration of the ground water in the lower' +
        ' part of the transition '
      '              zone, i.e. below drain level (EC in dS/m)'
      
        'CU0'#9'Initial salt concentration of the soil moisture, when at fie' +
        'ld saturation, in the '
      '              root zone of the non-irrigated land (EC in dS/m)'
      
        'Dc'#9'Critical depth of the water table for capillary rise (m), Dc ' +
        '> Dr'
      'Dd'#9'Depth of subsurface drains (m), Dd > Dr'
      'Dq'#9'Thickness of the aquifer (m)'
      'Dr'#9'Thickness of the root zone (m), Dr >0.1 > Dc'
      
        'Dx'#9'Thickness of the transition zone between root zone and aquife' +
        'r (m)'
      'Dw0'#9'Initial depth of the water table (m)'
      'EpA '#9'Potential evapo-transpiration of irrigated group A crop(s) '
      
        '              (m3/month per m2 irrigated area under group A crop' +
        's)'
      
        'EpB '#9'Potential evapo-transpiration of irrigated group B crop(s) ' +
        ' '
      
        '              (m3/month per m2 irrigated area under group B crop' +
        's)'
      'EpU '#9'Potential evapo-transpiration of non-irrigated area '
      '              (m3/month per m2 non-irrigated area)'
      'Flq'#9'Leaching efficiency of the aquifer (-),  Fla > 0'
      'Flr'#9'Leaching efficiency of the root zone (-),  Flr > 0'
      'Flt'#9'Leaching efficiency of the transition zone (-),  Flt > 0'
      
        'Frd'#9'Reduction factor of the drainage function for water table co' +
        'ntrol or for partial '
      '               drainage of the area (-)'
      
        'FsA '#9'Storage efficiency of irrigation and rain water in irrigate' +
        'd land under group A '
      
        '              crop(s): fraction of irrigation and rainwater stor' +
        'ed in the root zone of A crop(s), '
      
        '              average of all irrigations and rain storms (-),  0' +
        ' < FsA < 1'
      
        'FsB'#9'Storage efficiency of irrigation and rain water in irrigated' +
        ' land under group B '
      
        '              crop(s): fraction of irrigation and rain water sto' +
        'red in the root zone of B crop(s), '
      
        '              average for all irrigations and rain storms (-),  ' +
        '0 < FsB < 1'
      
        'FsU'#9'Efficiency of rain water in non-irrigated land: fraction of ' +
        'rainwater stored in '
      
        '              the root zone of non-irrigated lands as an average' +
        ' for all rain storms (-),'
      '              0 < FsU < 1'
      
        'Fw'#9'Fraction of pumped well water used for irrigation (-),  0 < F' +
        'w < 1'
      'Gu'#9'Subsurface drainage water used for irrigation'
      '              (m3/month per m2 total area),  Gu < Gd'
      'Gi'#9'Horizontally incoming ground water flow through the aquifer'
      '              (m3/month per m2 total area)'
      'Go'#9'Horizontally outgoing ground water flow through the aquifer '
      '              (m3/month per m2 total area)'
      'Gw'#9'Ground water pumped from wells in the aquifer'
      '              (m3/month per m2 total area)'
      
        'IaA'#9'Irrigation water applied to the irrigated fields under group' +
        ' A crop(s) '
      '              (m3/month per m2 area under group A crops)'
      
        'IaB'#9'Irrigation water applied to the irrigated fields under group' +
        ' B crop(s) i '
      '              (m3/month per m2 area under group B crops)'
      'Io'#9'Water leaving the area through the irrigation canal system '
      '              (bypass, m3/month per m2 total area)'
      'Kd'#9'Key for the presence of a subsurface drainage system: '
      '              yes -> Kd = 1, no -> Kd = 0'
      'Lc'#9'Percolation from the irrigation canal system in '
      '              (m3/month per m2 total area)'
      'Nm'#9'Number of months for model running (-)'
      
        'Peq'#9'Effective porosity (drainable or refillable pore space) of t' +
        'he aquifer (m/m), '
      '              0 < Peq < Ptq'
      
        'Per'#9'Effective porosity (drainable or refillable pore space) of t' +
        'he root zone (m/m), '
      '              0 < Per < Ptr'
      
        'Pex'#9'Effective porosity (drainable or refillable pore space) of t' +
        'he transition zone (m/m), '
      '              0 < Pex < Ptx'
      'Pp#'#9'Rainfall in month # (m3/month per m2 total area)'
      'Ptq'#9'Total pore space of the aquifer (m/m), Peq < Ptq < 1'
      'Ptr'#9'Total pore space of the root zone (m/m), Per < Ptr < 1'
      'Ptx'#9'Total pore space of transition zone (m/m), Pex < Ptx < 1'
      
        'QH1'#9'Ratio of drain discharge and height of the water table above' +
        ' drain level '
      '              (m/day per m)'
      
        'QH2'#9'Ratio of drain discharge and squared height of the water tab' +
        'le above drain level '
      '              (m/day per m2)'
      'RcA'#9'Whether group A crops is paddy (1) or not (0)'
      'RcA'#9'Whether group B crops is paddy (1) or not (0)'
      'SiU'#9'Surface inflow from surroundings into the non-irrigated area'
      '              (m3/month per m2 non-irrigated area)'
      
        'SoA'#9'Outgoing surface runoff or surface drain water from irrigate' +
        'd land under group '
      
        '              A crop(s)  (m3/month per m2 irrigated area under g' +
        'roup A crops)'
      
        'SoB'#9'Outgoing surface runoff or surface drain water from irrigate' +
        'd land under group '
      
        '              B crop(s) (m3/month per m2 irrigated area under gr' +
        'oup B crops)'
      'SoU'#9'Outgoing surface runoff water from the non-irrigated area '
      '              (m3/month per m2 non-irrigated area)')
    ScrollBars = ssVertical
    TabOrder = 1
  end
  object InputSymbolsButton: TButton
    Left = 536
    Top = 416
    Width = 65
    Height = 25
    Caption = 'Close'
    TabOrder = 2
    OnClick = InputSymbolsButtonClick
  end
end
