unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UBaseForm, ComCtrls, StdCtrls, StdActns, ActnList, Menus, Mask,
  ExtCtrls, ShellApi, jpeg, Grids, clipbrd;

Type

  Tlabels1 = array [1..22] of Tlabel;
  TLabels4 = array [1..4,1..4] of TLabel;
  TEdits4 = array [1..4,1..4] of TEdit;
  TLabels8 = array [4..15,1..8] of TLabel;
  TEdits8 = array [4..15,1..8] of TEdit;

  TMainForm = class(TBaseForm)
                                            {Menu bar}
    ActionList1: TActionList;
    InputOpen: TAction;
    InputSave: TAction;
    OutputOpen: TAction;
    GraphOpen: TAction;
    GraphSave: TAction;
    FilePrint: TAction;
    GroupSave: TAction;
    GroupOpen: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    InputOpen1: TMenuItem;
    OpenOutput1: TMenuItem;
    GraphOpen1: TMenuItem;
    ProgramExit1: TMenuItem;
    Edit: TMenuItem;
    Cut: TMenuItem;
    CopyIt: TMenuItem;
    Paste: TMenuItem;
    DeleteIt: TMenuItem;
    FilePrint1: TMenuItem;
    OpenGroup: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditDelete1: TEditDelete;
    EditPaste1: TEditPaste;
    FileExit1: TFileExit;
    PageControl1: TPageControl;
    InputOpen_Dialog: TOpenDialog;
    GraphOpen_Dialog: TOpenDialog;
    GraphSave_Dialog: TSaveDialog;
    GroupOpen_Dialog: TOpenDialog;
    InputSave_Dialog: TSaveDialog;
    OutputOpen_Dialog: TOpenDialog;
    GroupSave_Dialog: TSaveDialog;
                                             {Intro tabsheet}
    Intro_Tabsheet: TTabSheet;
    Intro_Memo: TMemo;
    LogoImage: TImage;
                                            {Input tabsheet}
    Input_TabSheet: TTabSheet;
    Filesave_Button: TButton;
    FileOpen_Button: TButton;
    InputSymbols_Button: TButton;
    Title1_Edit: TEdit;
    Title2_Edit: TEdit;
    TotAreaEdit: TEdit;
    MonthsEdit: TEdit;
    ExplainEdit1: TEdit;
    ExplainEdit2: TEdit;
    Filename_Label: TLabel;
    Title1_Label: TLabel;
    Title2_Label: TLabel;
    TotAreaLabel: TLabel;
    DrainageCombo: TComboBox;
    RiceACombo: TComboBox;
    RiceBCombo: TComboBox;
    TimeStepCombo: TComboBox;
    TimeStepLabel: TLabel;
    Memo1: TMemo;
    DrainageLabel: TLabel;
    MonthsLabel: TLabel;
    ExplainLabel1: TLabel;
    ExplainLabel2: TLabel;
    ScrollBox1: TScrollBox;
    AreaAEdit: TEdit;
    AreaALabel: TLabel;
    AreaBLabel: TLabel;
    AreaBEdit: TEdit;
    RiceALabel: TLabel;
    RiceBLabel: TLabel;
    IrrALabel: TLabel;
    IrrAEdit: TEdit;
    IrrBLabel: TLabel;
    IrrBEdit: TEdit;
    Line1Label: TLabel;
    Line3Label: TLabel;
    Line2Label: TLabel;
    RainLabel: TLabel;
    RainEdit: TEdit;
    EvapALabel: TLabel;
    EvapAEdit: TEdit;
    EvapBLabel: TLabel;
    EvapBEdit: TEdit;
    EvapUEdit: TEdit;
    EvapULabel: TLabel;
    Line4Label: TLabel;
    StorEffALabel: TLabel;
    StorEffAEdit: TEdit;
    StorEffBLabel: TLabel;
    StorEffBEdit: TEdit;
    StorEffULabel: TLabel;
    StorEffUEdit: TEdit;
    Line5Label: TLabel;
    GrwtInLabel: TLabel;
    GrwtInEdit: TEdit;
    GrwtOutLabel: TLabel;
    GrwtOutEdit: TEdit;
    SurfDrALabel: TLabel;
    SurfDrAEdit: TEdit;
    SurfDrBLabel: TLabel;
    SurfDrBEdit: TEdit;
    SurfInULabel: TLabel;
    SurfInUEdit: TEdit;
    SurfOutULabel: TLabel;
    SurfOutUEdit: TEdit;
    Line6Label: TLabel;
    WellsPumpLabel: TLabel;
    WellsPumpEdit: TEdit;
    WellsUseLabel: TLabel;
    WellsUseEdit: TEdit;
    Line7Label: TLabel;
    RootZoneLabel: TLabel;
    RootZoneEdit: TEdit;
    TransZoneLabel: TLabel;
    TransZoneEdit: TEdit;
    AquifZoneLabel: TLabel;
    AquifZoneEdit: TEdit;
    TotPorRootLabel: TLabel;
    TotPorRootEdit: TEdit;
    TotPorTransLabel: TLabel;
    TotPorTransEdit: TEdit;
    TotPorAquifLabel: TLabel;
    TotPorAquifEdit: TEdit;
    EffPorRootLabel: TLabel;
    EffPorRootEdit: TEdit;
    EffPorTransLabel: TLabel;
    EffPorTransEdit: TEdit;
    EffPorAquifLabel: TLabel;
    EffPorAquifEdit: TEdit;
    Line8Label: TLabel;
    InitSalRootAEdit: TEdit;
    InitSalRootBLabel: TLabel;
    InitSalRootBEdit: TEdit;
    InitSalRootULabel: TLabel;
    InitSalRootUEdit: TEdit;
    InitSalRootALabel: TLabel;
    Line9Label: TLabel;
    InitSalTransLabel: TLabel;
    InitSalTransEdit: TEdit;
    InitSalTransALabel: TLabel;
    InitSalTransAEdit: TEdit;
    InitSalTransBLabel: TLabel;
    InitSalTransBEdit: TEdit;
    InitSalAquifLabel: TLabel;
    InitSalAquifEdit: TEdit;
    line10Label: TLabel;
    Line11Label: TLabel;
    IrrSalLabel: TLabel;
    IrrSalEdit: TEdit;
    GrwtSalInLabel: TLabel;
    GrwtSalInEdit: TEdit;
    RainSalLabel: TLabel;
    RainSalEdit: TEdit;
    Line12Label: TLabel;
    LeachEffRootLabel: TLabel;
    LeachEffRootEdit: TEdit;
    LeachEffTransLabel: TLabel;
    LeachEffTransEdit: TEdit;
    LeachEffAquifLabel: TLabel;
    LeachEffAquifEdit: TEdit;
    Line13Label: TLabel;
    DepthWTLabel: TLabel;
    DepthWTEdit: TEdit;
    CritDepthLabel: TLabel;
    CritDepthEdit: TEdit;
    LossesLabel: TLabel;
    LossesEdit: TEdit;
    BypassLabel: TLabel;
    BypassEdit: TEdit;
    Line14Label: TLabel;
    DrainDepthLabel: TLabel;
    DrainDepthEdit: TEdit;
    QH1Label: TLabel;
    QH1Edit: TEdit;
    QH2Label: TLabel;
    QH2Edit: TEdit;
    DrControlLabel: TLabel;
    DrControlEdit: TEdit;
    DrReuseLabel: TLabel;
    DrReuseEdit: TEdit;
    EndLabel: TLabel;
                                            {Figure tabsheet}
    Figure_TabSheet: TTabSheet;
    Figure_Image: TImage;
                                            {Output tabsheet}
    Output_TabSheet: TTabSheet;
    OutputFile_Button: TButton;
    OutputSymbols_Button: TButton;
    Group_Button: TButton;
    Go_Button: TButton;
    Cancel_Button: TButton;
    GroupOpenButton: TButton;
    ViewGraph_Button: TButton;
    SaveGroupButton: TButton;
    SaltImage1: TImage;
    Output_Memo: TMemo;
    WaitMemo: TMemo;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton10: TRadioButton;
                                           {Graphics tabsheet}
    Graphics_TabSheet: TTabSheet;
    OutputFileButton: TButton;
    GroupFileButton: TButton;
    SaveGraph_Button: TButton;
    SeeGraphButton: TButton;
    ShowSymbolsButton: TButton;
    CloseOutput_Button: TButton;
    GraphImage: TImage;
    SaltImage2: TImage;
    FileNameLabel: TLabel;
    FigureButton: TButton;
    OutGrid: TStringGrid;
    ClipButton: TButton;
    ClipMemo: TMemo;
        {General}
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Intro_TabsheetShow(Sender: TObject);
    procedure FilePrint_Execute(Sender: TObject);
        {Input}
    procedure Input_TabSheetShow(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure LabelEnter(Sender: TObject);
    procedure ComboEnter(Sender: TObject);
//    procedure ComboKdIndexExit(Sender: TObject);
    procedure DrainageComboChange(Sender: TObject);
    procedure EditNrOfYearsExit(Sender: TObject);
    procedure EditIrrAreaAExit(Sender: TObject);
    procedure EditIrrAreaBExit(Sender: TObject);
    procedure GrwtInEditExit(Sender: TObject);
    procedure EditPumpingExit(Sender: TObject);
    procedure EditPumpingChange(Sender: TObject);
    procedure InputSymbols_ButtonClick(Sender: TObject);
    procedure InputOpen_Execute(Sender: TObject);
    procedure InputSave_Execute (Sender: TObject);
    function  StringToFloat(Str : string) : double;
        {Figure}
    procedure Figure_TabSheetShow(Sender: TObject);
    procedure FigureButtonClick(Sender: TObject);
        {Output}
    procedure Output_TabSheetShow(Sender: TObject);
    procedure OutputOpen_Execute(Sender: TObject);
    procedure CloseOutput_ButtonClick(Sender: TObject);
    procedure GroupOpen_Execute(Sender: TObject);
    procedure OutputSymbols_ButtonClick(Sender: TObject);
    procedure Group_ButtonClick(Sender: TObject);
    procedure Go_ButtonClick(Sender: TObject);
    procedure Cancel_ButtonClick(Sender: TObject);
    procedure GroupSave_Execute (Sender: TObject);
    procedure ViewGraph_ButtonClick(Sender: TObject);
    procedure ClipButtonClick(Sender: TObject);
         {Graphics}
    procedure Graphics_TabSheetShow(Sender: TObject);
    procedure GraphOpen_Execute(Sender: TObject);
    procedure GraphSave_Execute(Sender: TObject);
    procedure ShowSymbolsButtonClick(Sender: TObject);
        {Finish}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimeStepComboExit(Sender: TObject);

  private
       {Input}
    NoSave, OutputOpened,
    InputOpened, GraphOpened,
    GroupOpened, RunTimeError,
    RunTimeWarning           : boolean;
       {Input}
    procedure MakeStrings;
    procedure MakeValues;
    function  SetAndVerifySaveName : boolean;
    function  SetAndVerifyGroupName : boolean;
    procedure DoCalculations;
    procedure Calculate;
    procedure MonthlyMessages;
       {Output}
    procedure ShowOutputGroup(const GroupSign : string);
      {Graphics}
    procedure ShowGraphics;
      {General}
    procedure SetInitialDir (AuxDir:string);

  public
    InitDir, DataFile,
    OriginalDir, DataDir : string;
    NrOfErrorLines, NrOfWarningLines : integer;
    FirstMonth, AllZero : boolean;
    InitDecSep          : char;

  end;

var
  MainForm: TMainForm;

implementation

uses UDataMod, UCloseForm, UCalculate,UExtraUtils, UHelpForm,
     UInputSymbolsForm, UOutputSymbolsForm, UWarningForm;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
{----------------------------------------------}
begin
  inherited;
  PageControl1.ActivePageIndex := 0;     {Introduction tabsheet}
  Scrollbox1.VertScrollBar.Position:=0;
  InitDir:=Getcurrentdir;
  SetInitialDir (InitDir);
  InputSave.Enabled := false;
  OutputOpened := false;
  GroupOpened := false;
  InputOpened := false;
  GraphOpened := false;
  FirstMonth:=true;
  AreaALabel.Hint := 'Irrigated area under group A crops,'+
         ' fraction of total area (fraction, 0 < A < 1)';
  AreaAEdit.Hint := AreaALabel.Hint;
  AreaBLabel.Hint := 'Irrigated area under group B crops,'+
         ' fraction of total area (fraction, 0 < B < 1)';
  AreaBEdit.Hint := AreaBLabel.Hint;
  RiceALabel.Hint := 'Whether irrigated A area is under a rice'+
         ' crop (no/yes)';
  RiceACombo.Hint := RiceALabel.Hint;
  RiceBLabel.Hint := 'Whether irrigated B area is under a rice'+
         ' crop (no/yes)';
  RiceBCombo.Hint := RiceBLabel.Hint;
  IrrALabel.Hint := 'Irrigation field application to area under ' +
        'group A crops (m3/Tstep per m2 total A area). Excludes re-use '+
        'of drain and well water';
  IrrAEdit.Hint := IrrALabel.Hint;
  IrrBLabel.Hint := 'Irrigation field application to area under ' +
        'group B crops (m3/Tstep per m2 total B area). Excludes re-use '+
        'of drain and well water';
  IrrBEdit.Hint := IrrBLabel.Hint;
  RainLabel.Hint := 'Rainfall, precipitaion (m/Tstep)';
  RainEdit.Hint := RainLabel.Hint;
  EvapALabel.Hint := 'Potential evapotranspiration of group A crops'+
                     ' (m/Tstep)';
  EvapAEdit.Hint := EvapALabel.Hint;
  EvapBLabel.Hint := 'Potential evapotranspiration of group B crops'+
                     ' (m/Tstep)';
  EvapBEdit.Hint := EvapBLabel.Hint;
  EvapULabel.Hint := 'Potential evaporation from unirrigated (U) land'+
                     ' (m/Tstep)';
  EvapUEdit.Hint := EvapULabel.Hint;
  StorEffALabel.Hint := 'Storage efficiency of water in the soil of the'+
                ' irrigated land under   group A crops (fraction, 0<FsA<1)';
  StorEffAEdit.Hint := StorEffALabel.Hint;
  StorEffBLabel.Hint := 'Storage efficiency of water in the soil of the'+
                ' irrigated land under   group B crops (fraction, 0<FsB<1)';
  StorEffBEdit.Hint := StorEffBLabel.Hint;
  StorEffULabel.Hint := 'Storage efficiency of water in the soil of the'+
                ' unirrigated (U) land   (fraction, 0<FsU<1)';
  StorEffUEdit.Hint := StorEffULabel.Hint;
  GrwtInLabel.Hint := 'Incoming ground water flow in the aquifer'+
                      ' (m3/Tstep per m2 total area)';
  GrwtInEdit.Hint := GrwtInLabel.Hint;
  GrwtOutLabel.Hint := 'Outgoing ground water flow through the aquifer'+
                      ' (m3/Tstep per m2 total area)';
  GrwtOutEdit.Hint := GrwtOutLabel.Hint;
  SurfDrALabel.Hint := 'Surfcace drainage from the irrigated land under'+
                       ' group A crops         (m3/Tstep per m2 A area)';
  SurfDrAEdit.Hint := SurfDrALabel.Hint;
  SurfDrBLabel.Hint := 'Surfcace drainage from the irrigated land under'+
                       ' group B crops         (m3/Tstep per m2 B area)';
  SurfDrBEdit.Hint := SurfDrBLabel.Hint;
  SurfInULabel.Hint := 'Surfcace surface inflow (flooding) into unirrigated'+
                       ' (U) land (m3/Tstep per  m2 U area)';
  SurfInUEdit.Hint := SurfInULabel.Hint;
  SurfOutULabel.Hint := 'Surfcace drainage/runoff from the unirrigated'+
                       ' (U) land  (m3/Tstep per m2 U area)';
  SurfOutUEdit.Hint := SurfOutULabel.Hint;
  WellsPumpLabel.Hint := 'Pumping of ground water by wells'+
                     ' (m3/Tstep per m2 total area)';
  WellsPumpEdit.Hint := WellsPumpLabel.Hint;
  WellsUseLabel.Hint := 'Fraction of well water used for irrigation'+
                       ' (0 < Fw < 1)';
  WellsUseEdit.Hint := WellsUseLabel.Hint;
  RootZoneLabel.Hint := 'Thickness of the root zone (m)';
  RootZoneEdit.Hint := RootZoneLabel.Hint;
  TransZoneLabel.Hint := 'Thickness of the transition zone between'+
                         ' root zone and aquifer (m)';
  TransZoneEdit.Hint := TransZoneLabel.Hint;
  AquifZoneLabel.Hint := 'Thickness of the aquifer (m)';
  AquifZoneEdit.Hint := AquifZoneLabel.Hint;
  TotPorRootLabel.Hint := 'Total soil porosity of the root zone (m/m, Ptr<1)';
  TotPorRootEdit.Hint := TotPorRootLabel.Hint;
  TotPorTransLabel.Hint := 'Total soil porosity of the transition zone'+
                           ' (m/m, Ptx<1)';
  TotPorTransEdit.Hint := TotPorTransLabel.Hint;
  TotPorAquifLabel.Hint := 'Total soil porosity of the aquifer'+
                           ' (m/m, Ptq<1)';
  TotPorAquifEdit.Hint := TotPorAquifLabel.Hint;
  EffPorRootLabel.Hint := 'Drainable soil porosity of the root zone'+
                          ' (m/m, Per<Ptr)';
  EffPorRootEdit.Hint := EffPorRootLabel.Hint;
  EffPorTransLabel.Hint := 'Drainable soil porosity of the transition zone'+
                           ' (m/m, Pex<Ptx)';
  EffPorTransEdit.Hint := EffPorTransLabel.Hint;
  EffPorAquifLabel.Hint := 'Drainable soil porosity of the aquifer'+
                           ' (m/m, Peq<Ptq)';
  EffPorAquifEdit.Hint := EffPorAquifLabel.Hint;
  InitSalRootALabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' root zone, when saturated of irrigated A land'+
                           ' (dS/m)';
  InitSalRootAEdit.Hint := InitSalRootALabel.Hint;
  InitSalRootBLabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' root zone, when saturated of irrigated B land'+
                           ' (dS/m)';
  InitSalRootBEdit.Hint := InitSalRootBLabel.Hint;
  InitSalRootULabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' root zone, when saturated of unirrigated (U)'+
                           ' land (dS/m)';
  InitSalRootUEdit.Hint := InitSalRootULabel.Hint;
  InitSalTransLabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' transitiom zone, when    saturated (dS/m)';
  InitSalTransEdit.Hint := InitSalTransLabel.Hint;
  InitSalTransALabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' transition zone above    drain level (dS/m)';
  InitSalTransAEdit.Hint := InitSalTransALabel.Hint;
  InitSalTransBLabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' transitiom zone below    drain level (dS/m)';
  InitSalTransBEdit.Hint := InitSalTransBLabel.Hint;
  InitSalAquifLabel.Hint := 'Initial salinity of the soil moisture in the'+
                           ' aquifer, when saturated  (dS/m)';
  InitSalAquifEdit.Hint := InitSalAquifLabel.Hint;
  IrrSalLabel.Hint := 'Salinity of the irrigation water (dS/m)';
  IrrSalEdit.Hint := IrrSalLabel.Hint;
  GrwtSalInLabel.Hint := 'Salinity of the horizontally incoming'+
                         ' ground water (dS/m)';
  GrwtSalInEdit.Hint := GrwtSalInLabel.Hint;
  RainSalLabel.Hint := 'Salinity of the rainfall/precipitation (dS/m)';
  RainSalEdit.Hint := RainSalLabel.Hint;
  LeachEffRootLabel.Hint := 'Leaching efficiency of the root zone (fraction)';
  LeachEffRootEdit.Hint := LeachEffRootLabel.Hint;
  LeachEffTransLabel.Hint := 'Leaching efficiency of the transition zone'+
                             ' (fraction)';
  LeachEffTransEdit.Hint := LeachEffTransLabel.Hint;
  LeachEffAquifLabel.Hint := 'Leaching efficiency of the aquifer (fraction)';
  LeachEffAquifEdit.Hint := LeachEffAquifLabel.Hint;
  DepthWTLabel.Hint := 'Depth of the water table below soil surface (m)';
  DepthWTEdit.Hint := DepthWTLabel.Hint;
  CritDepthLabel.Hint := 'Critical depth of the water table below soil'+
                         ' surface for capillary    rise (m)';
  CritDepthEdit.Hint := CritDepthLabel.Hint;
  LossesLabel.Hint := 'Percolation losses from the irrigation canals to'+
                      ' the underground      (m3/Tstep per m2 total area)';
  LossesEdit.Hint := LossesLabel.Hint;
  BypassLabel.Hint := 'Bypass of irrigation water in the canal system'+
                      ' to downstream area     (m3/Tstep per m2 total area)';
  BypassEdit.Hint := BypassLabel.Hint;
  DrainDepthLabel.Hint := 'Depth of the subsurface drainage system below'+
                          ' soil surface (m)';
  DrainDepthEdit.Hint := DrainDepthLabel.Hint;
  QH1Label.Hint := 'Discharge capacity factor of the subsurface drainage'+
                   ' system for flow  above drain level (m/day per m height'+
                   ' of water table above drain level)';
  QH1Edit.Hint := QH1Label.Hint;
  QH2Label.Hint := 'Discharge factor of the subsurface drainage system'+
                   ' for flow above     drain level (m/day per m2 height'+
                   ' of water table above drain level)';
  QH2Edit.Hint := QH2Label.Hint;
  DrControlLabel.Hint := 'Drainage control factor to reduce the drain'+
                         ' discharge (fraction,      0<Frd<0)';
  DrControlEdit.Hint := DrControlLabel.Hint;
  DrReuseLabel.Hint := 'Reuse of drainage water for irrigation'+
                       ' (m3/Tstep per m2 total area)';
  DrReuseEdit.Hint := DrReuseLabel.Hint;

  InitDecSep := DecimalSeparator;

end;{TMainForm.FormCreate}
{------------------------}


{******************************************************************************
 Introduction TabSheet
 ******************************************************************************}

procedure TMainForm.Intro_TabsheetShow(Sender: TObject);
begin
  inherited;
  StatusText ('Use the Input tabsheet to continue');
  InputSave.Enabled := false;
  DataMod.Ns := 1;
  DataMod.Kr := 0;
  DataMod.Ky := 1;
  DataMod.MonthNr := 0;
end;


{******************************************************************************
 Input TabSheet
 ******************************************************************************}


procedure TMainForm.Input_TabSheetShow(Sender: TObject);
{------------------------------------------------------}
begin Inherited;
      Scrollbox1.VertScrollBar.Position:=0;
      StatusText('Enter data or use "Open" to see examples of input files in' +
            ' any folder or to edit existing files. Thereafter use' +
            ' "Save / run".');
      InputSave.Enabled := true;
      if (OutputOpened) then MakeStrings;
      if not InputOpened then
      begin
        DataMod.Ns := 1;
        DataMod.Kd := 1;
        DataMod.Kf := 0;
        DataMod.Kr := 0;
        DataMod.A[1]:=0.5;
        DataMod.B[1]:=0.3;
        GrwtSalInLabel.Enabled:=false;
        GrwtSalInEdit.Enabled:=false;
        InitSalTransLabel.Enabled:=false;
        InitSalTransEdit.Enabled:=false;
        DataMod.TimeStep := 'Month';
        TimeStepCombo.ItemIndex:=0;
      end;
      if InputOpened then
      begin
        if DataMod.TimeStep='Month' then TimeStepCombo.ItemIndex:=0;
        if DataMod.TimeStep='Week' then TimeStepCombo.ItemIndex:=1;
        if DataMod.TimeStep='Day' then TimeStepCombo.ItemIndex:=2;
      end;
end; {TMainForm.Data_TabSheetShow}
{--------------------------------}


{See also InputOpen_Execute in Group MenuBar Buttons}


procedure TMainForm.EditEnter(Sender: TObject);
{---------------------------------------------}
var MemoLine, MemoLine1, MemoLine2 : string;
begin Inherited;
      MemoLine := (Sender as Tedit).Hint;
      if length(MemoLine)>70 then
      begin
        MemoLine1 := copy(MemoLine,1,70);
        MemoLine2 := copy(MemoLine,71,length(MemoLine));
        ExplainEdit1.Visible := true;
        ExplainEdit1.Text := Memoline1;
        ExplainEdit2.Text := MemoLine2;
      end else
      begin
        ExplainEdit2.Text := MemoLine;
        ExplainEdit1.Visible := false;
      end;
end; {TMainForm.EditEnter}
{------------------------}



procedure TMainForm.LabelEnter(Sender: TObject);
{---------------------------------------------}
var MemoLine, MemoLine1, MemoLine2 : string;
begin Inherited;
      MemoLine := (Sender as TLabel).Hint;
      if length(MemoLine)>70 then
      begin
        MemoLine1 := copy(MemoLine,1,70);
        MemoLine2 := copy(MemoLine,71,length(MemoLine));
        ExplainEdit1.Visible := true;
        ExplainEdit1.Text := Memoline1;
        ExplainEdit2.Text := MemoLine2;
      end else
      begin
        ExplainEdit2.Text := MemoLine;
        ExplainEdit1.Visible := false;
      end;
end; {TMainForm.LabelEnter}
{-------------------------}


procedure TMainForm.ComboEnter(Sender: TObject);
{----------------------------------------------}
var MemoLine, MemoLine1, MemoLine2 : string;
begin
  inherited;
      MemoLine := (Sender as TComboBox).Hint;
      if length(MemoLine)>70 then
      begin
        MemoLine1 := copy(MemoLine,1,70);
        MemoLine2 := copy(MemoLine,71,length(MemoLine));
        ExplainEdit1.Visible := true;
        ExplainEdit1.Text := Memoline1;
        ExplainEdit2.Text := MemoLine2;
      end else
      begin
        ExplainEdit2.Text := MemoLine;
        ExplainEdit1.Visible := false;
      end;
end; {TMainForm.ComboEnter}
{-------------------------}



procedure TMainForm.TimeStepComboExit(Sender: TObject);
begin
  inherited;
  if TimeStepCombo.ItemIndex=0 then DataMod.TimeStep:='Month';
  if TimeStepCombo.ItemIndex=1 then DataMod.TimeStep:='Week';
  if TimeStepCombo.ItemIndex=2 then DataMod.TimeStep:='Day';
end;



procedure TMainForm.DrainageComboChange(Sender: TObject);
//procedure TMainForm.ComboKdIndexExit(Sender: TObject);
{----------------------------------------------------}
begin
  inherited;
   DataMod.Kd := DrainageCombo.ItemIndex;
   if DataMod.Kd=0 then
   begin
     InitSalTransLabel.Enabled:=true;
     InitSalTransEdit.Enabled:=true;
     InitSalTransALabel.Enabled:=false;
     InitSalTransAEdit.Enabled:=false;
     InitSalTransAEdit.Text:='-1';
     InitSalTransBLabel.Enabled:=false;
     InitSalTransBEdit.Enabled:=false;
     InitSalTransBEdit.Text:='-1';
     Line14Label.Enabled:=false;
     DrainDepthLabel.Enabled:=false;
     DrainDepthEdit.Enabled:=false;
     DrainDepthEdit.Text:='-1';
     QH1Label.Enabled:=false;
     QH1Edit.Enabled:=false;
     QH1Edit.Text:='-1';
     QH2Label.Enabled:=false;
     QH2Edit.Enabled:=false;
     QH2Edit.Text:='-1';
     DrControlLabel.Enabled:=false;
     DrControlEdit.Enabled:=false;
     DrControlEdit.Text:='-1';
     DrReuseLabel.Enabled:=false;
     DrReuseEdit.Enabled:=false;
     DrReuseEdit.Text:='-1';
   end else
   begin
     InitSalTransLabel.Enabled:=false;
     InitSalTransEdit.Enabled:=false;
     InitSalTransAEdit.Text:='-1';
     InitSalTransAEdit.Enabled:=true;
     InitSalTransBLabel.Enabled:=true;
     InitSalTransBEdit.Enabled:=true;
     Line14Label.Enabled:=true;
     DrainDepthLabel.Enabled:=true;
     DrainDepthEdit.Enabled:=true;
     QH1Label.Enabled:=true;
     QH1Edit.Enabled:=true;
     QH2Label.Enabled:=true;
     QH2Edit.Enabled:=true;
     DrControlLabel.Enabled:=true;
     DrControlEdit.Enabled:=true;
     DrReuseLabel.Enabled:=true;
     DrReuseEdit.Enabled:=true;
   end;
end; {TMainForm.ComboKdIndexExit}
{-------------------------------}



procedure TMainForm.EditNrOfYearsExit(Sender: TObject);
{-----------------------------------------------------}
begin
  inherited;
  DataMod.Nm := StrToInt(MonthsEdit.Text);
  if DataMod.Nm>120 then
  begin
    if DataMod.TimeStep='Month' then
    Showmessage ('The number of months for calculations cannot be'+
                 ' more than 120');
    if DataMod.TimeStep='Week' then
    Showmessage ('The number of weeks for calculations cannot be'+
                 ' more than 132');
    if DataMod.TimeStep='Day' then
    Showmessage ('The number of days for calculations cannot be'+
                 ' more than 365');
    MonthsEdit.Text := '120';
    if DataMod.TimeStep='Week' then MonthsEdit.Text := '132';
    if DataMod.TimeStep='Day' then MonthsEdit.Text := '365';
    DataMod.Nm := 120;
    if DataMod.TimeStep='Week' then DataMod.Nm := 132;
    if DataMod.TimeStep='Day' then DataMod.Nm := 365;
  end;
end; {TMainForm.EditNrOfYearsExit}
{--------------------------------}



procedure TMainForm.EditIrrAreaAExit(Sender: TObject);
{----------------------------------------------------}
begin Inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
         begin
           Showmessage ('The irrigated area fraction cannot be negative');
           (Sender as TEdit).Text := '0';
           exit;
         end;
      if (StringToFloat((Sender as TEdit).Text)>1) then
         begin
           Showmessage ('The irrigated area fraction cannot be greater' +
                        ' than unity');
           (Sender as TEdit).Text := '1';
         end;
      DataMod.A[1]:=StringToFloat((Sender as TEdit).Text);
      if DataMod.A[1]+DataMod.B[1]>=1 then
      begin
        EvapULabel.Enabled:=false;
        EvapUEdit.Enabled:=false;
        EvapUEdit.Text:='-1';
        StorEffULabel.Enabled:=false;
        StorEffUEdit.Enabled:=false;
        StorEffUEdit.Text:='-1';
        SurfInULabel.Enabled:=false;
        SurfInUEdit.Enabled:=false;
        SurfInUEdit.Text:='-1';
        SurfOutULabel.Enabled:=false;
        SurfOutUEdit.Enabled:=false;
        SurfOutUEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end else
      begin
        EvapULabel.Enabled:=true;
        EvapUEdit.Enabled:=true;
        StorEffULabel.Enabled:=true;
        StorEffUEdit.Enabled:=true;
        SurfInULabel.Enabled:=true;
        SurfInUEdit.Enabled:=true;
        SurfOutULabel.Enabled:=true;
        SurfOutUEdit.Enabled:=true;
        InitSalRootULabel.Enabled:=true;
        InitSalRootUEdit.Enabled:=true;
      end;
      if DataMod.A[1]>=1 then
      begin
        AreaBEdit.Enabled:=false;
        AreaBLabel.Enabled:=false;
        AreaBEdit.Text:='-1';
        IrrBEdit.Enabled:=false;
        IrrBLabel.Enabled:=false;
        IrrBEdit.Text:='-1';
        RiceBCombo.ItemIndex:=0;
        RiceBCombo.Enabled:=false;
        RiceBLabel.Enabled:=false;
        EvapBLabel.Enabled:=false;
        EvapBEdit.Enabled:=false;
        EvapBEdit.Text:='-1';
        StorEffBLabel.Enabled:=false;
        StorEffBEdit.Enabled:=false;
        StorEffBEdit.Text:='-1';
        SurfDrBLabel.Enabled:=false;
        SurfDrBEdit.Enabled:=false;
        SurfDrBEdit.Text:='-1';
        InitSalRootBLabel.Enabled:=false;
        InitSalRootBEdit.Enabled:=false;
        InitSalRootBEdit.Text:='-1';
      end else
      begin
        AreaBEdit.Enabled:=true;
        AreaBLabel.Enabled:=true;
        IrrBEdit.Enabled:=true;
        IrrBLabel.Enabled:=true;
        RiceBCombo.Enabled:=true;
        RiceBLabel.Enabled:=true;
        EvapBLabel.Enabled:=true;
        EvapBEdit.Enabled:=true;
        StorEffBLabel.Enabled:=true;
        StorEffBEdit.Enabled:=true;
        SurfDrBLabel.Enabled:=true;
        SurfDrBEdit.Enabled:=true;
        InitSalRootBLabel.Enabled:=true;
        InitSalRootBEdit.Enabled:=true;
      end;
      if DataMod.B[1]>=1 then
      begin
        AreaAEdit.Enabled:=false;
        AreaALabel.Enabled:=false;
        AreaAEdit.Text:='-1';
        IrrAEdit.Enabled:=false;
        IrrALabel.Enabled:=false;
        IrrAEdit.Text:='-1';
        RiceACombo.ItemIndex:=0;
        RiceACombo.Enabled:=false;
        RiceALabel.Enabled:=false;
        EvapALabel.Enabled:=false;
        EvapAEdit.Enabled:=false;
        EvapAEdit.Text:='-1';
        StorEffALabel.Enabled:=false;
        StorEffAEdit.Enabled:=false;
        StorEffAEdit.Text:='-1';
        SurfDrALabel.Enabled:=false;
        SurfDrAEdit.Enabled:=false;
        SurfDrAEdit.Text:='-1';
        InitSalRootALabel.Enabled:=false;
        InitSalRootAEdit.Enabled:=false;
        InitSalRootAEdit.Text:='-1';
      end else
      begin
        if (DataMod.A[1]>0) then
        begin
        AreaAEdit.Enabled:=true;
        AreaALabel.Enabled:=true;
        IrrAEdit.Enabled:=true;
        IrrALabel.Enabled:=true;
        RiceACombo.Enabled:=true;
        RiceALabel.Enabled:=true;
        EvapALabel.Enabled:=true;
        EvapAEdit.Enabled:=true;
        StorEffALabel.Enabled:=true;
        StorEffAEdit.Enabled:=true;
        SurfDrALabel.Enabled:=true;
        SurfDrAEdit.Enabled:=true;
        InitSalRootALabel.Enabled:=true;
        InitSalRootAEdit.Enabled:=true;
      end;
    end;
end; {TMainForm.EditIrrAreaAExit}
{-------------------------------}



procedure TMainForm.EditIrrAreaBExit(Sender: TObject);
{----------------------------------------------------}
begin Inherited;
      Try                             {test of het echt een real is}
//      begin
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
             ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
         begin
           Showmessage ('The irrigated area fraction cannot be negative');
           (Sender as TEdit).Text := '0';
           exit;
         end;
      if (StringToFloat((Sender as TEdit).Text)>1) then
         begin
           Showmessage ('The irrigated area fraction cannot be greater' +
                        ' than unity');
           (Sender as TEdit).Text := '1';
         end;
      DataMod.B[1]:=StringToFloat((Sender as TEdit).Text);
      if DataMod.A[1]+DataMod.B[1]>=1 then
      begin
        EvapULabel.Enabled:=false;
        EvapUEdit.Enabled:=false;
        EvapUEdit.Text:='-1';
        StorEffULabel.Enabled:=false;
        StorEffUEdit.Enabled:=false;
        StorEffUEdit.Text:='-1';
        SurfInULabel.Enabled:=false;
        SurfInUEdit.Enabled:=false;
        SurfInUEdit.Text:='-1';
        SurfOutULabel.Enabled:=false;
        SurfOutUEdit.Enabled:=false;
        SurfOutUEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end else
      begin
        EvapULabel.Enabled:=true;
        EvapUEdit.Enabled:=true;
        StorEffULabel.Enabled:=true;
        StorEffUEdit.Enabled:=true;
        SurfInULabel.Enabled:=true;
        SurfInUEdit.Enabled:=true;
        SurfOutULabel.Enabled:=true;
        SurfOutUEdit.Enabled:=true;
        InitSalRootULabel.Enabled:=true;
        InitSalRootUEdit.Enabled:=true;
      end;
      if DataMod.B[1]>=1 then
      begin
        AreaAEdit.Enabled:=false;
        AreaALabel.Enabled:=false;
        AreaAEdit.Text:='-1';
        IrrAEdit.Enabled:=false;
        IrrALabel.Enabled:=false;
        IrrAEdit.Text:='-1';
        RiceACombo.ItemIndex:=0;
        RiceACombo.Enabled:=false;
        RiceALabel.Enabled:=false;
        EvapALabel.Enabled:=false;
        EvapAEdit.Enabled:=false;
        EvapAEdit.Text:='-1';
        StorEffALabel.Enabled:=false;
        StorEffAEdit.Enabled:=false;
        StorEffAEdit.Text:='-1';
        SurfDrALabel.Enabled:=false;
        SurfDrAEdit.Enabled:=false;
        SurfDrAEdit.Text:='-1';
        InitSalRootALabel.Enabled:=false;
        InitSalRootAEdit.Enabled:=false;
        InitSalRootAEdit.Text:='-1';
      end else
      begin
//        if DataMod.A[1]>0 then
//        begin
        AreaAEdit.Enabled:=true;
        AreaALabel.Enabled:=true;
        IrrAEdit.Enabled:=true;
        IrrBLabel.Enabled:=true;
        RiceACombo.Enabled:=true;
        RiceALabel.Enabled:=true;
        EvapALabel.Enabled:=true;
        EvapAEdit.Enabled:=true;
        StorEffALabel.Enabled:=true;
        StorEffAEdit.Enabled:=true;
        SurfDrALabel.Enabled:=true;
        SurfDrALabel.Enabled:=true;
        InitSalRootALabel.Enabled:=true;
        InitSalRootAEdit.Enabled:=true;
//        end;
      end;
      if DataMod.A[1]>=1 then
      begin
        AreaBEdit.Enabled:=false;
        AreaBLabel.Enabled:=false;
        AreaBEdit.Text:='-1';
        IrrBEdit.Enabled:=false;
        IrrBLabel.Enabled:=false;
        IrrBEdit.Text:='-1';
        RiceBCombo.ItemIndex:=0;
        RiceBCombo.Enabled:=false;
        RiceBLabel.Enabled:=false;
        EvapBLabel.Enabled:=false;
        EvapBEdit.Enabled:=false;
        EvapBEdit.Text:='-1';
        StorEffBLabel.Enabled:=false;
        StorEffBEdit.Enabled:=false;
        StorEffBEdit.Text:='-1';
        SurfDrBLabel.Enabled:=false;
        SurfDrBEdit.Enabled:=false;
        SurfDrBEdit.Text:='-1';
        InitSalRootBLabel.Enabled:=false;
        InitSalRootBEdit.Enabled:=false;
        InitSalRootBEdit.Text:='-1';
      end else
      begin
        if (DataMod.B[1]>0) then
        begin
        AreaBEdit.Enabled:=true;
        AreaBLabel.Enabled:=true;
        IrrBEdit.Enabled:=true;
        IrrBLabel.Enabled:=true;
        RiceBCombo.Enabled:=true;
        RiceBLabel.Enabled:=true;
        EvapBLabel.Enabled:=true;
        EvapBEdit.Enabled:=true;
        StorEffBLabel.Enabled:=true;
        StorEffBEdit.Enabled:=true;
        SurfDrBLabel.Enabled:=true;
        SurfDrBEdit.Enabled:=true;
        InitSalRootBLabel.Enabled:=true;
        InitSalRootBEdit.Enabled:=true;
        end;
      end;
end; {TMainForm.EditIrrAreaBExit}
{-------------------------------}



procedure TMainForm.GrwtInEditExit(Sender: TObject);
begin
  inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
               ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
      begin
        Showmessage ('The ground water inflow cannot be negative');
        (Sender as TEdit).Text := '0';
        exit;
      end;
      DataMod.Gi[1]:=StringToFloat((Sender as TEdit).Text);
      if DataMod.Gi[1]=0 then
      begin
        GrwtSalInLabel.Enabled:=false;
        GrwtSalInEdit.Enabled:=false;
        GrwtSalInEdit.Text:='-1';
      end else
      begin
        GrwtSalInLabel.Enabled:=true;
        GrwtSalInEdit.Enabled:=true;
      end;
end;



function TMainForm.StringToFloat(Str : string) : double;
{------------------------------------------------------}
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TSegRegForm.StringToFloat}
{------------------------------}



procedure TMainForm.EditPumpingExit(Sender: TObject);
{---------------------------------------------------}
begin Inherited;
      Try                             {test of het echt een real is}
         (Sender as TEdit).Text :=
             FloatToStr(StringToFloat((Sender as TEdit).Text));
         Except on E: exception do
         begin
           ShowMessage
               ((Sender as TEdit).Text + ' is not a valid real');
           (Sender as TEdit).Text := '0';
           DecimalSeparator := InitDecSep;
           exit;
         end;
      end;
      if (StringToFloat((Sender as TEdit).Text)<0) then
      begin
        Showmessage ('The Pumping from wells cannot be negative');
        (Sender as TEdit).Text := '0';
        exit;
      end;
      DataMod.Gw[1]:=StringToFloat((Sender as TEdit).Text);
      if DataMod.Gw[1]=0 then
      begin
        WellsUseLabel.Enabled:=false;
        WellsUseEdit.Enabled:=false;
      end else
      begin
        WellsUseLabel.Enabled:=true;
        WellsUseEdit.Enabled:=true;
      end;
end; {TMainForm.EditPumpingExit}
{------------------------------}



procedure TMainForm.EditPumpingChange(Sender: TObject);
{-------------------------------------------------------}
var HlpVar : real;
begin
  inherited;
    if ((Sender as TEdit).Text)='' then exit
    else
    Try
      HlpVar := StringToFloat ((Sender as TEdit).Text);          {Pumping}
      Except on E: exception do
      begin
        DecimalSeparator := InitDecSep;
        exit;
      end;
    end;
    if (HlpVar>0) then
    begin
      WellsUseEdit.Enabled:=true;
      WellsUseLabel.Enabled:=true;
    end else
    begin
      WellsUseEdit.Text:='-1';
      WellsUseEdit.Enabled:=false;
      WellsUseLabel.Enabled:=false;
    end;
end;{TMainForm.EditPumpingChange}
{-------------------------------}



procedure TMainForm.InputSymbols_ButtonClick(Sender: TObject);
{------------------------------------------------------------}
begin
  inherited;
  InputSymbolsForm.Show;
end; {TMainForm.InputSymbols_ButtonClick}
{---------------------------------------}



procedure TMainForm.MakeStrings;
{------------------------------}
var AB : real;
begin
  with DataMod do
  begin
    TotAreaEdit.Text := floattostr(Area);
    DrainageCombo.ItemIndex := Kd;
    MonthsEdit.Text := IntToStr(Nm);
    AreaAEdit.Text := floattostr(A[1]);
    AreaBEdit.Text := floattostr(B[1]);
    RiceACombo.ItemIndex := RcA[1];
    RiceBCombo.ItemIndex := RcB[1];
    LossesEdit.Text := floattostr(Lc[1]);
    BypassEdit.Text := floattostr(Io[1]);
    IrrAEdit.Text := floattostr(IaA[1]);
    IrrBEdit.Text := floattostr(IaB[1]);
    EvapAEdit.Text := floattostr(EpA[1]);
    EvapBEdit.Text := floattostr(EpB[1]);
    EvapUEdit.Text := floattostr(EpU[1]);
    InitSalRootAEdit.Text := floattostr(CA0);
    InitSalRootBEdit.Text := floattostr(CB0);
    InitSalRootUEdit.Text := floattostr(CU0);
    AB:=A[1]+B[1];
    if A[1]=-1 then AB:=B[1];
    if B[1]=-1 then AB:=A[1];
    if AB>=1 then
    begin
      EvapUEdit.Text := '-1';
      EvapUEdit.Enabled := false;
      EvapULabel.Enabled := false;
    end else
    begin
      EvapUEdit.Enabled := true;
      EvapULabel.Enabled := true;
    end;
    if (A[1]>=1) or ((A[1]<1) and (B[1]<=0))then
    begin
      IrrBEdit.Text := '-1';
      if (A[1]>=1) then IrrBEdit.Enabled := false;
      if (A[1]>=1) then IrrBLabel.Enabled := false;
      AreaBEdit.Text := '-1';
      if (A[1]>=1) then AreaBEdit.Enabled := false;
      if (A[1]>=1) then AreaBLabel.Enabled := false;
      EvapBEdit.Text := '-1';
      if (A[1]>=1) then EvapBEdit.Enabled := false;
      if (A[1]>=1) then EvapBLabel.Enabled := false;
      RiceBCombo.ItemIndex:=0;
      if (A[1]>=1) then RiceBCombo.Enabled:=false;
      if (A[1]>=1) then RiceBLabel.Enabled:=false;
      if (A[1]>=1) then
      begin
        InitSalRootBLabel.Enabled:=false;
        InitSalRootBEdit.Enabled:=false;
        InitSalRootBEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end;
    end else
    begin
      IrrBEdit.Enabled := true;
      IrrBLabel.Enabled := true;
      AreaBEdit.Enabled := true;
      AreaBLabel.Enabled := true;
      EvapBEdit.Enabled := true;
      EvapBLabel.Enabled := true;
      RiceBCombo.Enabled:=true;
      RiceBLabel.Enabled:=true;
      InitSalRootBLabel.Enabled:=true;
      InitSalRootBEdit.Enabled:=true;
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
    end;
    if (B[1]>=1) or ((B[1]<1) and (A[1]<=0))then
    begin
      IrrAEdit.Text := '-1';
      if (B[1]>=1) then IrrAEdit.Enabled := false;
      if (B[1]>=1) then IrrALabel.Enabled := false;
      AreaAEdit.Text := '-1';
      if (B[1]>=1) then AreaAEdit.Enabled := false;
      if (B[1]>=1) then AreaALabel.Enabled := false;
      EvapAEdit.Text := '-1';
      if (B[1]>=1) then EvapAEdit.Enabled := false;
      if (B[1]>=1) then EvapALabel.Enabled := false;
      RiceACombo.ItemIndex:=0;
      if (B[1]>=1) then RiceACombo.Enabled:=false;
      if (B[1]>=1) then RiceALabel.Enabled:=false;
      if (B[1]>=1) then
      begin
        InitSalRootALabel.Enabled:=false;
        InitSalRootAEdit.Enabled:=false;
        InitSalRootAEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end;
    end else
    begin
      IrrAEdit.Enabled := true;
      IrrALabel.Enabled := true;
      AreaAEdit.Enabled := true;
      AreaALabel.Enabled := true;
      EvapAEdit.Enabled := true;
      EvapALabel.Enabled := true;
      RiceACombo.Enabled:=true;
      RiceALabel.Enabled:=true;
      InitSalRootBLabel.Enabled:=true;
      InitSalRootBEdit.Enabled:=true;
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
    end;
    RainEdit.Text := floattostr(Pp[1]);
    StorEffAEdit.Text := floattostr(FsA[1]);
    StorEffBEdit.Text := floattostr(FsB[1]);
    StorEffUEdit.Text := floattostr(FsU[1]);
    if AB>=1 then
    begin
      StorEffUEdit.Text := '-1';
      StorEffUEdit.Enabled := false;
      StorEffULabel.Enabled := false;
      InitSalRootULabel.Enabled:=false;
      InitSalRootUEdit.Enabled:=false;
      InitSalRootUEdit.Text:='-1';
    end else
    begin
      StorEffUEdit.Enabled := true;
      StorEffULabel.Enabled := true;
    end;
    if (A[1]>=1) or ((A[1]<1) and (B[1]<=0))then
    begin
      StorEffBEdit.Text := '-1';
      if (A[1]>=1) then StorEffBEdit.Enabled := false;
      if (A[1]>=1) then StorEffBLabel.Enabled := false;
      if (A[1]>=1) then
      begin
        InitSalRootBLabel.Enabled:=false;
        InitSalRootBEdit.Enabled:=false;
        InitSalRootBEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end;
    end else
    begin
      StorEffBEdit.Enabled := true;
      StorEffBLabel.Enabled := true;
      InitSalRootBLabel.Enabled:=true;
      InitSalRootBEdit.Enabled:=true;
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
    end;
    if (B[1]>=1) or ((B[1]<1) and (A[1]<=0))then
    begin
      StorEffAEdit.Text := '-1';
      if (B[1]>=1) then StorEffAEdit.Enabled := false;
      if (B[1]>=1) then StorEffALabel.Enabled := false;
      if (B[1]>=1) then
      begin
        InitSalRootALabel.Enabled:=false;
        InitSalRootAEdit.Enabled:=false;
        InitSalRootAEdit.Text:='-1';
        InitSalRootULabel.Enabled:=false;
        InitSalRootUEdit.Enabled:=false;
        InitSalRootUEdit.Text:='-1';
      end;
    end else
    begin
      StorEffAEdit.Enabled := true;
      StorEffALabel.Enabled := true;
      InitSalRootALabel.Enabled:=true;
      InitSalRootAEdit.Enabled:=true;
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
    end;
    GrwtInEdit.Text := floattostr(Gi[1]);
    GrwtOutEdit.Text := floattostr(Go[1]);
    SurfDrAEdit.Text := floattostr(SoA[1]);
    SurfDrBEdit.Text := floattostr(SoB[1]);
    SurfInUEdit.Text := floattostr(SiU[1]);
    SurfOutUEdit.Text := floattostr(SoU[1]);
    if AB>=1 then
    begin
      SurfInUEdit.Text := '-1';
      SurfInUEdit.Enabled := false;
      SurfInULabel.Enabled := false;
      SurfOutUEdit.Text := '-1';
      SurfOutUEdit.Enabled := false;
      SurfOutULabel.Enabled := false;
      InitSalRootULabel.Enabled:=false;
      InitSalRootUEdit.Enabled:=false;
      InitSalRootUEdit.Text:='-1';
    end else
    begin
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
      SurfInUEdit.Enabled := true;
      SurfInULabel.Enabled := true;
      SurfOutUEdit.Enabled := true;
      SurfOutULabel.Enabled := true;
      InitSalRootULabel.Enabled:=true;
      InitSalRootUEdit.Enabled:=true;
    end;
    WellsPumpEdit.Text := floattostr(Gw[1]);
    WellsUseEdit.Text := floattostr(Fw[1]);
    if Gw[1]<=0 then
    begin
      WellsUseEdit.Text := '-1';
      WellsUseEdit.Enabled:=false;
      WellsUseLabel.Enabled:=false;
    end else
    begin
      WellsUseEdit.Enabled:=true;
      WellsUseLabel.Enabled:=true;
    end;
    RootZoneEdit.Text := floattostr(Dr);
    TransZoneEdit.Text := floattostr(Dx);
    AquifZoneEdit.Text := floattostr(Dq);
    TotPorRootEdit.Text := floattostr(Ptr);
    TotPorTransEdit.Text := floattostr(Ptx);
    TotPorAquifEdit.Text := floattostr(Ptq);
    EffPorRootEdit.Text := floattostr(Per);
    EffPorTransEdit.Text := floattostr(Pex);
    EffPorAquifEdit.Text := floattostr(Peq);
    LeachEffRootEdit.Text := floattostr(Flr);
    LeachEffTransEdit.Text := floattostr(Flx);
    LeachEffAquifEdit.Text := floattostr(Flq);
    InitSalTransEdit.Text := floattostr(Cx0);
    InitSalTransAEdit.Text := floattostr(Cxa0);
    InitSalTransBEdit.Text := floattostr(Cxb0);
    InitSalAquifEdit.Text := floattostr(Cq0);
    IrrSalEdit.Text := floattostr(Cic);
    GrwtSalInEdit.Text := floattostr(Ch);
    if Gi[1]<=0 then
    begin
      GrwtSalInEdit.Text := '-1';
      GrwtSalInEdit.Enabled :=false;
      GrwtSalInLabel.Enabled:=false;
    end else
    begin
      GrwtSalInEdit.Enabled :=true;
      GrwtSalInLabel.Enabled:=true;
    end;
    RainSalEdit.Text := floattostr(Cp);
    DepthWtEdit.Text := floattostr(Dw0);
    CritDepthEdit.Text := floattostr(Dc);
    if Kd>0 then
    begin
      Line14Label.Enabled:=true;
      InitSalTransEdit.Enabled:=false;
      InitSalTransLabel.Enabled:=false;
      InitSalTransEdit.Text:='-1';
      InitSalTransAEdit.Enabled:=true;
      InitSalTransALabel.Enabled:=true;
      InitSalTransBLabel.Enabled:=true;
      InitSalTransBEdit.Enabled:=true;
      DrainDepthEdit.Text := floattostr(Dd);
      DrainDepthEdit.Enabled := true;
      DrainDepthLabel.Enabled := true;
      QH1Edit.Text := floattostr(QH1);
      QH1Edit.Enabled := true;
      QH1Label.Enabled := true;
      QH2Edit.Text := floattostr(QH2);
      QH2Edit.Enabled := true;
      QH2Label.Enabled := true;
      DrControlEdit.Text := floattostr(Frd[1]);
      DrControlEdit.Enabled := true;
      DrControlLabel.Enabled:=true;
      DrReuseEdit.Text := floattostr(Gu[1]);
      DrReuseEdit.Enabled := true;
      DrReuseLabel.Enabled := true;
    end else
    begin
      Line14Label.Enabled:=false;
      InitSalTransEdit.Enabled:=true;
      InitSalTransLabel.Enabled:=true;
      InitSalTransAEdit.Enabled:=false;
      InitSalTransAEdit.Text:='-1';
      InitSalTransBLabel.Enabled:=false;
      InitSalTransBEdit.Enabled:=false;
      InitSalTransBEdit.Text:='-1';
      InitSalTransALabel.Enabled:=false;
      InitSalTransBLabel.Enabled:=false;
      DrainDepthEdit.Text := '-1';
      DrainDepthEdit.Enabled := false;
      DrainDepthLabel.Enabled := false;
      QH1Edit.Text := '-1';
      QH1Edit.Enabled := false;
      QH1Label.Enabled := false;
      QH2Edit.Text := '-1';
      QH2Edit.Enabled := false;
      QH2Label.Enabled := false;
      DrControlEdit.Text := '-1';
      DrControlEdit.Enabled := false;
      DrControlLabel.Enabled:=false;
      DrReuseEdit.Text := '-1';
      DrReuseEdit.Enabled := false;
      DrReuseLabel.Enabled := false;
    end;
  end; {with DataMod do}
end; {TMainForm.MakeStrings}
{--------------------------}


procedure TMainForm.MakeValues;
{-----------------------------}
begin
  with DataMod do
  begin
    if TimeStepCombo.ItemIndex=0 then Timestep:='Month';
    if TimeStepCombo.ItemIndex=1 then Timestep:='Week';
    if TimeStepCombo.ItemIndex=2 then Timestep:='Day';
    Area := StringToFloat(TotAreaEdit.Text);
    Kd := DrainageCombo.ItemIndex;
    Nm := StrToInt(MonthsEdit.Text);
    A[1]:= StringToFloat(AreaAEdit.Text);
    B[1]:= StringToFloat(AreaBEdit.Text);
    RcA[1]:= RiceACombo.ItemIndex;
    RcB[1]:= RiceBCombo.ItemIndex;
    Lc[1]:= StringToFloat(LossesEdit.Text);
    Io[1]:= StringToFloat(BypassEdit.Text);
    if A[1]>0 then
       IaA[1]:= StringToFloat(IrrAEdit.Text)
    else IaA[1]:=-1;
    if B[1]>0 then
       IaB[1]:= StringToFloat(IrrBEdit.Text)
    else IaB[1]:=-1;
    if A[1]>=1 then
    begin
       IaB[1]:=-1;
       AreaBEdit.Enabled:=false;
       AreaBLabel.Enabled:=false;
       RiceBCombo.ItemIndex:=0;
       RiceBCombo.Enabled:=false;
       RiceBLabel.Enabled:=false;
    end else
    begin
       AreaBEdit.Enabled:=true;
       AreaBLabel.Enabled:=true;
       RiceBCombo.Enabled:=true;
       RiceBLabel.Enabled:=true;
    end;
    if B[1]>=1 then
    begin
       IaA[1]:=-1;
       AreaAEdit.Enabled:=false;
       AreaALabel.Enabled:=false;
       RiceACombo.ItemIndex:=0;
       RiceACombo.Enabled:=false;
       RiceALabel.Enabled:=false;
    end else
    begin
       AreaAEdit.Enabled:=true;
       AreaALabel.Enabled:=true;
       RiceACombo.Enabled:=true;
       RiceALabel.Enabled:=true;
    end;
    if A[1]>0 then
       EpA[1]:= StringToFloat(EvapAEdit.Text)
    else EpA[1]:=-1;
    if A[1]>=1 then
    begin
       EpB[1]:=-1;
       EvapBEdit.Enabled:=false;
       EvapBLabel.Enabled:=false;
    end else
    begin
       EvapBEdit.Enabled:=true;
       EvapBLabel.Enabled:=true;
    end;
    if B[1]>0 then
       EpB[1]:= StringToFloat(EvapBEdit.Text)
    else EpB[1]:=-1;
    if B[1]>=1 then
    begin
       EpA[1]:=-1;
       EvapAEdit.Enabled:=false;
       EvapALabel.Enabled:=false;
    end else
    begin
       EvapAEdit.Enabled:=true;
       EvapALabel.Enabled:=true;
    end;
    if A[1]+B[1]<1 then
       EpU[1]:= StringToFloat(EvapUEdit.Text)
    else EpU[1]:=-1;
    Pp[1]:= StringToFloat(RainEdit.Text);
    if A[1]>0 then
       FsA[1]:= StringToFloat(StorEffAEdit.Text)
    else FsA[1]:=-1;
    if B[1]>0 then
       FsB[1]:= StringToFloat(StorEffBEdit.Text)
    else FsB[1]:=-1;
    if A[1]+B[1]<1 then
       FsU[1]:= StringToFloat(StorEffUEdit.Text)
    else FsU[1]:=-1;
    Gi[1]:= StringToFloat(GrwtInEdit.Text);
    Go[1]:= StringToFloat(GrwtOutEdit.Text);
    if A[1]>0 then
       SoA[1]:= StringToFloat(SurfDrAEdit.Text)
    else SoA[1]:=-1;
    if A[1]>=1 then
    begin
       SoB[1]:=-1;
       SurfDrBEdit.Enabled:=false;
       SurfDrBLabel.Enabled:=false;
    end else
    begin
       SurfDrBEdit.Enabled:=true;
       SurfDrBLabel.Enabled:=true;
    end;
    if B[1]>0 then
       SoB[1]:= StringToFloat(SurfDrBEdit.Text)
    else SoB[1]:=-1;
    if B[1]>=1 then
    begin
       SoA[1]:=-1;
       SurfDrAEdit.Enabled:=false;
       SurfDrALabel.Enabled:=false;
    end else
    begin
       SurfDrAEdit.Enabled:=true;
       SurfDrALabel.Enabled:=true;
    end;
    if A[1]+B[1]<1 then
    begin
      SurfInUEdit.Enabled:=true;
      SurfOutUEdit.Enabled:=true;
      SurfInULabel.Enabled:=true;
      SurfOutULabel.Enabled:=true;
      SiU[1]:= StringToFloat(SurfInUEdit.Text);
      SoU[1]:= StringToFloat(SurfOutUEdit.Text);
    end else
    begin
      SiU[1]:=-1;
      SoU[1]:=-1;
      SurfInUEdit.Enabled:=false;
      SurfOutUEdit.Enabled:=false;
      SurfInULabel.Enabled:=false;
      SurfOutULabel.Enabled:=false;
    end;
    if (A[1]>=1) or (B[1]>=1) then
    begin
      SurfInUEdit.Enabled:=true;
      SurfOutUEdit.Enabled:=true;
      SurfInULabel.Enabled:=true;
      SurfOutULabel.Enabled:=true;
      SiU[1]:= StringToFloat(SurfInUEdit.Text);
      SoU[1]:= StringToFloat(SurfOutUEdit.Text);
    end else
    begin
      SiU[1]:=-1;
      SoU[1]:=-1;
      SurfInUEdit.Enabled:=false;
      SurfOutUEdit.Enabled:=false;
      SurfInULabel.Enabled:=false;
      SurfOutULabel.Enabled:=false;
    end;
    Gw[1]:= StringToFloat(WellsPumpEdit.Text);
    if Gw[1]>0 then
       Fw[1]:= StringToFloat(WellsUseEdit.Text)
    else Fw[1]:=-1;
    Dr := StringToFloat(RootZoneEdit.Text);
    Dx := StringToFloat(TransZoneEdit.Text);
    Dq := StringToFloat(AquifZoneEdit.Text);
    Ptr := StringToFloat(TotPorRootEdit.Text);
    Ptx := StringToFloat(TotPorTransEdit.Text);
    Ptq := StringToFloat(TotPorAquifEdit.Text);
    Per := StringToFloat(EffPorRootEdit.Text);
    Pex := StringToFloat(EffPorTransEdit.Text);
    Peq := StringToFloat(EffPorAquifEdit.Text);
    Flr := StringToFloat(LeachEffRootEdit.Text);
    Flx := StringToFloat(LeachEffTransEdit.Text);
    Flq := StringToFloat(LeachEffAquifEdit.Text);
    Cx0 := StringToFloat(InitSalTransEdit.Text);
    Cxa0 := StringToFloat(InitSalTransAEdit.Text);
    Cxb0 := StringToFloat(InitSalTransBEdit.Text);
    Cq0 := StringToFloat(InitSalAquifEdit.Text);
    Cic := StringToFloat(IrrSalEdit.Text);
    Ch := StringToFloat(GrwtSalInEdit.Text);
    Cp := StringToFloat(RainSalEdit.Text);
    CA0 := StringToFloat(InitSalRootAEdit.Text);
    CB0 := StringToFloat(InitSalRootBEdit.Text);
    CU0 := StringToFloat(InitSalRootUEdit.Text);
    Dw0 := StringToFloat(DepthWtEdit.Text);
    Dc := StringToFloat(CritDepthEdit.Text);
    if DrainageCombo.ItemIndex>0 then
    begin
      Dd := StringToFloat(DrainDepthEdit.Text);
      QH1 := StringToFloat(QH1Edit.Text);
      QH2 := StringToFloat(QH2Edit.Text);
      Frd[1] := StringToFloat(DrControlEdit.Text);
      Gu[1] := StringToFloat(DrReuseEdit.Text);
    end else
    begin
      Dd := -1;
      QH1 := -1;
      QH2 := -1;
      Frd[1] := -1;
      Gu[1] := -1;
    end;
  end; {with DataMod do}
end; {TMainForm.MakeValues}
{-------------------------}



function TMainForm.SetAndVerifySaveName;
{--------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if InputSave_Dialog.Execute then with DataMod do
      begin DataMod.FileName := InputSave_Dialog.Files.Strings[0];
        FileName := ChangeFileExt(FileName,'.INP');
        if FileExists(DataMod.FileName)
        then  Result :=
              Question('The file already exists, overwrite?')
        else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.VerifySaveName}
{-----------------------------}



function TMainForm.SetAndVerifyGroupName;
{---------------------------------------}
begin Inherited;
      NoSave:=false;
      Result := false;
      if GroupSave_Dialog.Execute then with DataMod do
      begin DataMod.FileName := GroupSave_Dialog.Files.Strings[0];
        FileName := ChangeFileExt(FileName,'.prn');
        if FileExists(DataMod.FileName)
        then  Result :=
              Question('The file already exists, overwrite?')
        else  Result := true;
      end
      else NoSave:=true;
end; {TMainForm.VerifySaveName}
{-----------------------------}


procedure TMainForm.DoCalculations;
{---------------------------------}
begin
  WaitMemo.Visible:=true;
  WaitMemo.Lines.Clear;
  WaitMemo.Lines.Add(' Calculating .....');
  CheckInputs;                                             {in unit ExtraUtils}
  DataMod.ReadErrorLines (RunTimeError,NrOfErrorLines);
  deletefile ('Error.lst');
  CalcDone := true;
  if RunTimeError then with DataMod do
  begin
    showmessage ('One or more errors in the input were detected.');
    OutputOpened:=false;
    GroupOpenButton.Visible:=false;
    CloseOutput_Button.Visible:=false;
    OutputSymbols_Button.Visible:=false;
    Output_Tabsheet.Show;
    WaitMemo.Visible:=false;
    FileName := ChangeFileExt(FileName,'.res');
    if fileexists (FileName) then deletefile (FileName);
    FileName := ChangeFileExt(FileName,'.frq');
    if fileexists (FileName) then deletefile (FileName);
    deletefile ('Warning.lst');
    exit;
  end;
  WTdepth:=false;
  Calculations;
  DataMod.ReadWarningLines (RunTimeWarning,NrOfWarningLines);;
  deletefile ('Warning.lst');
  GroupOpenButton.Visible:=true;
  CloseOutput_Button.Visible:=true;
  OutputSymbols_Button.Visible:=true;
end; {TMainForm.DoCalculations}
{-----------------------------}


procedure TMainForm.Calculate;
{----------------------------}
begin
     DoCalculations;
     if RuntimeError then exit;
     WaitMemo.Lines.Add(' Finalizing ......');
     Sleep(500);
     WaitMemo.Visible:=false;
     if not WTdepth then MonthlyMessages;
     if RunTimeWarning then with DataMod do
     begin
       showmessage ('One or more runtime warnings are given.');
       WarningForm.Visible:=true;
     end;
end; {Calculate}
{--------------}


procedure TMainForm.MonthlyMessages;
{----------------------------------}
var OldMonth, NewMonth, InterFile, Nx : string;
    Result, Answer : boolean;
begin
  with DataMod do
  begin
    OldMonth := IntToStr(MonthNr);
    MonthNr:=MonthNr+1;
    NewMonth := IntToStr(MonthNr);
    InterFile := ChangeFileExt(OriginalName,'.res');
    Nx := IntToStr(Nm);
    if(MonthNr<Nm+1) then
    begin
       Showmessage ('SaltCalcD calculations using the input'+
       ' file  '+FileName+'  for a time series of  '+Nx+'  time steps with'+
       ' the option to introduce input changes each timestep.  The end of the'+
       ' intermediate calculations of time step  '+OldMonth+ '  is'+
       ' reached. The intermediate results can be seen in output file  '
         +InterFile);
       Result := Question ('Do you wish to continue with the next'+
       ' time step '+NewMonth);
       if not Result then
       begin
          Showmessage ('The calculations for the time series are'+
         ' discontinued. Yet the intermediate results can be seen'+
         ' in  '+InterFile);
         YI:=0;
         YIp:=0;
         MonthNr:=1;
         EndOfCalc := true;
         exit;
       end;
       Answer:=false;
       if Result then Answer := Question ('Do you wish to make input changes?'+
          ' If not, the program does the calculations for the next time step'+
          ' straightaway.');
       if not Answer then
       begin
         OutGrid.Visible:=false;
         Calculate;
       end;
       if Answer then
         Showmessage ('Use the input menu to continue. It is not'+
         ' necessary to adjust the initial values of soil salinity'+
         ' and water level, this is done automatically. To keep'+
         ' record of input changes, the input file may be saved' +
         ' in the same folder under a different (sequential) name' +
         ' at each run. Use button Save/Run when ready.');
    end; {if MonthNr<Nm+1}
    if MonthNr=Nm+1 then
    begin
      Showmessage ('The end of the time series is reached. The results'+
      ' can be seen in  '+InterFile);
      YI:=0;
      YIp:=0;
      MonthNr:=1;
      EndOfCalc := true;
    end;
  end; {with DataMod do}
end; {TMainForm.MonthlyMessages}
{------------------------------}


{See also FileSave_Execute in Group MenuBar Buttons}


{******************************************************************************
 End of Input Tabsheet, start of Figure TabSheet
 ******************************************************************************}


procedure TMainForm.Figure_TabSheetShow(Sender: TObject);
begin Inherited;
    StatusText ('The figure gives explanations of symbols used in the' +
                ' input tabsheet');
end;{TMainForm.Figure_TabSheetShow}


procedure TMainForm.FigureButtonClick(Sender: TObject);
begin
  inherited;
  InputSymbolsForm.Show;
end;


{******************************************************************************
 End of Figure Tabsheet, start of Output TabSheet
 ******************************************************************************}


procedure TMainForm.Output_TabSheetShow(Sender: TObject);
{-------------------------------------------------------}
var k : integer;
    ReadingOK : boolean;
begin Inherited;
      InputSave.Enabled := false;
      StatusText ('Click "Output groups" or "Group file" to see graphs.'+
                  ' Alternatively click "Output file" to open an output file' +
                  ' to make graphs.');
      if not GroupOpened then OutGrid.Visible:=false;
      GroupOpened := false;
      Group_Button.Visible := true;
//      OutGrid.Visible:=false;
      ClipMemo.Visible:=false;
      ClipButton.Visible:=false;
      if not OutputOpened then
      begin
        Group_Button.Visible := false;
        SaveGroupButton.Visible := false;
        ViewGraph_Button.Visible := false;
        CloseOutput_Button.Visible:=false;
        OutputSymbols_Button.Visible:=false;
        if not RunTimeError then
        begin
          Output_Memo.Visible:= false;
          SaltImage1.Visible := true;
        end;
      end;
      if CalcDone then with DataMod do
      begin
       Output_Memo.Height:=424;
       FileName:=ChangeFileExt (OriginalName,'.res');
        if RunTimeError then
        begin
          deletefile (FileName);
          Output_Memo.Visible:=false;
          Output_Memo.Lines.Clear;
          for k:=0 to NrOfErrorLines-1 do Output_Memo.Lines.Add(ErrorLines[k]);
          Output_Memo.Lines.Add('');
          Output_Memo.Lines.Add (' CALCULATIONS COULD NOT BE DONE');
          Output_Memo.Lines.Add (' Please adjust the input.');
          Output_Memo.Visible:= true;
          setlength (ErrorLines,1);
        end else
        begin
          if RunTimeWarning then with DataMod do
          begin
            WarningForm.WarningMemo.Visible:=false;
            WarningForm.WarningMemo.Lines.Clear;
            WarningForm.WarningMemo.Lines.Add('');
            for k:=0 to NrOfWarningLines-1 do
                WarningForm.WarningMemo.Lines.Add(WarningLines[k]);
            WarningForm.WarningMemo.Lines.Add('');
            WarningForm.WarningMemo.Visible:=true;
            RunTimeWarning:=false;
          end;
          if WTdepth then if not DataMod.EndOfCalc then
          begin
            showmessage ('The watertable reached the bottom of the aquifer.'+
                         ' The output can be partially seen, but the'+
                         ' calculations cannot be continued. Please adjust'+
                         ' the input and start the procedure again.');
          end;
          Output_Memo.Visible := false;
          chdir (OriginalDir);                          //nodig? necessary?
          ReadOutputLines(FileName,ReadingOK);
          if not ReadingOk then exit;
          Output_Memo.Lines.Clear;
          for k:=1 to DataMod.NrOfLines do
            Output_Memo.Lines.Add(FileLine[k-1]);
          Output_Memo.Visible := true;
          GroupOpenButton.Visible:=true;
          CloseOutput_Button.Visible:=true;
          OutputSymbols_Button.Visible:=true;
          SaltImage1.Visible := false;
          ViewGraph_Button.Visible := false;
          SaveGroupButton.Visible := false;
          OutputSymbols_Button.Visible:=true;
        end; {if RunTimeError then else}
      end; {if CalcDone then with DataMod do}
      CalcDone:=false;
end; {TMainForm.Output_TabSheetShow}
{----------------------------------}


{see also OutputOpen_Execute in Group MenuBar buttons, activated when
 clicking on the SeeOutput_Button}


procedure TMainForm.OutputSymbols_ButtonClick(Sender: TObject);
{-------------------------------------------------------------}
begin
  inherited;
  OutputSymbolsForm.Show;
end; {TMainForm.OutputSymbols_ButtonClick}
{----------------------------------------}



procedure TMainForm.Group_ButtonClick(Sender: TObject);
{-----------------------------------------------------}
begin
  inherited;
  SaveGroupButton.Visible := false;
  ViewGraph_Button.Visible := false;
  OutGrid.Visible:=false;
  ClipMemo.Visible:=false;
  ClipButton.Visible:=false;
  Panel1.Show;
end; {TMainForm.Group_ButtonClick}
{--------------------------------}



procedure TMainForm.Go_ButtonClick(Sender: TObject);
{--------------------------------------------------}
var ii, jj, k : integer;
    ReadingOK : boolean;
begin
  inherited;
  ViewGraph_Button.Enabled:=true;
  Output_Memo.Height:=75;
  with DataMod do
  begin
    SaveGroupButton.Visible := true;
    ViewGraph_Button.Visible := true;
    ChangeFileExt(FileName,'.res');
    if RadioButton1.Checked then
    begin
       GroupMark := 'CrA';
       ReadOutputGroup('CrA');
       ShowOutputGroup('CrA');
    end else
    if RadioButton2.Checked then
    begin
       GroupMark := 'Cxf';
       ReadOutputGroup('Cxf');
       ShowOutputGroup('Cxf');
    end else
    if RadioButton3.Checked then
    begin
       GroupMark := 'Zs';
       ReadOutputGroup('Gd');
       ShowOutputGroup('Zs');
    end else
    if RadioButton4.Checked then
    begin
       GroupMark := 'Gd';
       ReadOutputGroup('Gd');
       ShowOutputGroup('Gd');
    end else
    if RadioButton5.Checked then
    begin
       GroupMark := 'Dw';
       ReadOutputGroup('Gd');
       for jj:=0 to DataMod.NrOfData-1 do
           DataMod.Variable[5,jj]:= -DataMod.Variable[5,jj];
       ShowOutputGroup('Dw');
    end else
    if RadioButton6.Checked then
    begin
       GroupMark := 'LrA';
       ReadOutputGroup('LrA');
       ShowOutputGroup('LrA');
    end else
    if RadioButton7.Checked then
    begin
       GroupMark := 'RrA';
       ReadOutputGroup('RrA');
       ShowOutputGroup('RrA');
    end else
    if RadioButton8.Checked then
    begin
       GroupMark := 'It';
       ReadOutputGroup('It');
       ShowOutputGroup('It');
    end else
    if RadioButton9.Checked then
    begin
       GroupMark := 'FfA';
       ReadOutputGroup('FfA');
       ShowOutputGroup('FfA');
       for ii:=1 to Datamod.NrOfitems do
         for jj:=0 to DataMod.NrOfData-1 do
             DataMod.Variable[ii,jj]:= 100*DataMod.Variable[ii,jj];
    end else
    if RadioButton10.Checked then
    begin
       GroupMark := 'EaU';
       ReadOutputGroup('FfA');
       ShowOutputGroup('EaU');
    end else
    if RadioButton11.Checked then
    begin
       GroupMark := 'A';
       ReadOutputGroup('A');
       ShowOutputGroup('A');
       for ii:=1 to Datamod.NrOfitems do
         for jj:=0 to DataMod.NrOfData-1 do
             DataMod.Variable[ii,jj]:= 100*DataMod.Variable[ii,jj];
    end else
    if RadioButton13.Checked then
    begin
      FileName:=ChangeFileExt(FileName,'.frq');
      ReadOutputLines (FileName,ReadingOK);
      if not ReadingOk then exit;
      Panel1.Hide;
      Output_Memo.Hide;
      ViewGraph_Button.Enabled:=false;
      Output_Memo.Lines.Clear;
      for k:=1 to DataMod.NrOfLines do
          Output_Memo.Lines.Add(FileLine[k-1]);
      Output_Memo.Height:=424;
      Output_Memo.Show;
      FileName:=ChangeFileExt(FileName,'.res');
    end
    else
      Panel1.Hide;
  end; {with DataMod do}
  if not RadioButton13.Checked then GroupOpened:=true;
end; {TMainForm.Go_ButtonClick}
{-----------------------------}



procedure TMainForm.ShowOutputGroup (const GroupSign : string);
{-------------------------------------------------------------}
var i, j, k, SeasonNr,YearNumber : integer;
begin
  Panel1.Hide;
  Output_Memo.Hide;
  Output_Memo.Lines.Clear;
  with DataMod do
  begin
    for i:=1 to 7 do PosValues[i]:=false;
    for i:=1 to NrOfitems do for k:=0 to NrOfData-1 do
      if Variable[i,k]>0 then PosValues[i]:=true;
    if GroupSign='Dw' then PosValues[5]:=true;
    setlength(FileLine,3);
    OutGrid.Cells[0,0]:='Month';
    if DataMod.TimeStep='Week' then OutGrid.Cells[0,0]:='Week';
    if DataMod.TimeStep='Day' then OutGrid.Cells[0,0]:='Day';
    if GroupSign='CrA' then
    begin
      FileLine[0] := ('"Soil salinities of the root zone'+
                      ' CrA (irr. A crops), CrB (irr. B crops)," ');
      FileLine[1] := ('"CrU (not irr.), Cr4 (full rotation), see symbols" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    CrA       CrB       CrU       Cr4');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    CrA       CrB       CrU       Cr4');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     CrA       CrB       CrU       Cr4');
      OutGrid.Cells[1,0]:=' CrA';
      OutGrid.Cells[2,0]:=' CrB';
      OutGrid.Cells[3,0]:=' CrU';
      OutGrid.Cells[4,0]:=' Cr4';
      OutGrid.Cells[5,0]:=' C1*';
      OutGrid.Cells[6,0]:=' C2*';
      OutGrid.Cells[7,0]:=' C3*';
    end;
    if GroupSign='Cxf' then
    begin
      FileLine[0] := ('"Salinity of the trans. zone (Cxf, Cxa, Cxb),'+
                      ' aquifer (Cqf), (mixed) irrigation" ');
      FileLine[1] := ('"water (Ci), drainage (Cd) and well water (Cw)'+
                      ' EC in dS/m, see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    Cxf       Cxa       Cxb       Cqf'+
                         '       Ci        Cd        Cw');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    Cxf       Cxa       Cxb       Cqf'+
                         '       Ci        Cd        Cw');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     Cxf       Cxa       Cxb       Cqf'+
                         '       Ci        Cd        Cw');
      OutGrid.Cells[1,0]:=' Cxf';
      OutGrid.Cells[2,0]:=' CxA';
      OutGrid.Cells[3,0]:=' CxB';
      OutGrid.Cells[4,0]:=' Cqf';
      OutGrid.Cells[5,0]:=' Ci';
      OutGrid.Cells[6,0]:=' Cd';
      OutGrid.Cells[7,0]:=' Cw';
    end;
    if GroupSign='Zs' then
    begin
      FileLine[0] := ('"Salt salt accumulation above the soil'+
                      ' surface (Zs) in m.dS/m per season" ');
      FileLine[1] := ('"only when the water table is above the'+
                      ' surface, see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    Zs');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    Zs');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     Zs');
      OutGrid.Cells[1,0]:=' Zs';
    end;
    if GroupSign='Gd' then
    begin
      FileLine[0] := ('"Drain (Gd, Ga, Gb) and well (Gw) discharge'+
                      ' in m/month" ');
      FileLine[1] := ('"Ga and Gb are drainage flows above and below'+
                      ' drain level, see symbols list" ');
      FileLine[2] := (' Month    Gd        Ga        Gb        Gw ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    Gd        Ga        Gb        Gw ');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    Gd        Ga        Gb        Gw ');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     Gd        Ga        Gb        Gw ');
      OutGrid.Cells[1,0]:=' Gd';
      OutGrid.Cells[2,0]:=' Ga';
      OutGrid.Cells[3,0]:=' Gb';
      OutGrid.Cells[4,0]:=' Gw';
    end;
    if GroupSign='Dw' then
    begin
      FileLine[0] := ('"Level of water the table (LWT in m) relative to the'+
                      ' soil surface" ');
      FileLine[1] := ('"When the watertable is below soil surface'+
                      ' the depth is given as a negative value" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month     Dw');
      if TimeStep='Week' then
         FileLine[2] := ('  Week     Dw');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     Dw');
      OutGrid.Cells[1,0]:=' Dw';
    end;
    if GroupSign='LrA' then
    begin
      FileLine[0] := ('"Water percolating down to the'+
                      ' water table in A land (LrA), B land (RrB)," ');
      FileLine[1] := ('"un-irr. land (LrU), and total area'+
                      ' average (Lr) in m/timestep, see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    LrA       LrB       LrU       Lr');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    LrA       LrB       LrU       Lr');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     LrA       LrB       LrU       Lr');
      OutGrid.Cells[1,0]:=' LrA';
      OutGrid.Cells[2,0]:=' LrB';
      OutGrid.Cells[3,0]:=' LrU';
      OutGrid.Cells[4,0]:=' Lrt';
    end;
    if GroupSign='RrA' then
    begin
      FileLine[0] := ('"Capillary rise of up from the'+
                      ' water table in A land (RrA), B land (RrB)," ');
      FileLine[1] := ('"un-irr. land (RrU) and total area'+
                      ' average (Rr) in m/timestep, see symbols list" ');
      if TimeStep='Month' then
          FileLine[2] := (' Month    RrA       RrB       RrU       Rr');
      if TimeStep='Week' then
          FileLine[2] := ('  Week    RrA       RrB       RrU       Rr');
      if TimeStep='Day' then
          FileLine[2] := ('  Day     RrA       RrB       RrU       Rr');
      OutGrid.Cells[1,0]:=' RrA';
      OutGrid.Cells[2,0]:=' RrB';
      OutGrid.Cells[3,0]:=' RrU';
      OutGrid.Cells[4,0]:=' Rrt';
    end;
    if GroupSign='It' then
    begin
      FileLine[0] := ('"Amounts of irrigation water (m/timestep),'+
                      ' It = total, Is = net, Io = bypass," ');
      FileLine[1] := ('"IaA and IaB are field applications'+
                      ' to land under A and B crops, see symbols" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    It        Is        Io '+
                         '       IaA       IaB');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    It        Is        Io '+
                         '       IaA       IaB');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     It        Is        Io '+
                         '       IaA       IaB');
      OutGrid.Cells[1,0]:=' It';
      OutGrid.Cells[2,0]:=' Is';
      OutGrid.Cells[3,0]:=' Io';
      OutGrid.Cells[4,0]:=' IaA';
      OutGrid.Cells[5,0]:=' IaB';
    end;
    if GroupSign='FfA' then
    begin
      FileLine[0] := ('"Irrigation efficiency in A (FfA) and B land (FfB)'+
                      ' and total (Fft)" ');
      FileLine[1] := ('"sufficiency in A (JsA) and B land (JsB),'+
                      ' fractions, see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    FfA       FfB       Fft'+
                         '       JsA       JsB');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    FfA       FfB       Fft'+
                         '       JsA       JsB');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     FfA       FfB       Fft'+
                         '       JsA       JsB');
      OutGrid.Cells[1,0]:=' FfA';
      OutGrid.Cells[2,0]:=' FfB';
      OutGrid.Cells[3,0]:=' Fft';
      OutGrid.Cells[4,0]:=' JsA';
      OutGrid.Cells[5,0]:=' JsB';
    end;
    if GroupSign='EaU' then
    begin
      FileLine[0] := ('"Actual evaporation from unirrigated land '+
                      ' EaU in m/timestep," ');
      FileLine[1] := ('"see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month    EaU');
      if TimeStep='Week' then
         FileLine[2] := ('  Week    EaU');
      if TimeStep='Day' then
         FileLine[2] := ('  Day     EaU');
      OutGrid.Cells[1,0]:=' EaU';
    end;
    if GroupSign='A' then
    begin
      FileLine[0] := ('"Area fraction of irrigated A land, B land, '+
                      ' un-irrigated land (U), see symbols list" ');
      if TimeStep='Month' then
         FileLine[2] := (' Month     A         B         U');
      if TimeStep='Week' then
         FileLine[2] := ('  Week     A         B         U');
      if TimeStep='Day' then
         FileLine[2] := ('  Day    A         B         U');
      OutGrid.Cells[1,0]:='  A';
      OutGrid.Cells[2,0]:='  B';
      OutGrid.Cells[3,0]:='  U';
    end;
    YearNumber:=0;
    SeasonNr:=0;
    for k:=1 to 7 do setlength(GridStr[k],DataMod.NrOfData+1);
    for k:=1 to NrOfData do
    begin
      setlength(FileLine,k+3);
      SeasonNr:=SeasonNr+1;
      if SeasonNr>Ns then
      begin
        YearNumber:=YearNumber+1;
        SeasonNr:=1;
      end;

      OutGrid.Cells[0,k]:=inttostr(YearNumber-1);
      if YearNumber<11 then
          FileLine[k+2]:=('  '+IntToStr(YearNumber-1)+'    ')
      else
          FileLine[k+2]:=(' '+IntToStr(YearNumber-1)+'    ');
      for i:= 1 to NrOfitems do
      begin
        if GroupSign<>'Dw' then
        begin
          if (DataMod.Variable[i,k-1]<0) and PosValues[i] then
              MainStr[i]:='   -      ';
          if (DataMod.Variable[i,k-1]<0) and not PosValues[i] then
              MainStr[i]:='  n.a.    ';
          if (DataMod.Variable[i,k-1]>=0) and not PosValues[i] then
              MainStr[i]:='   -      ';
          GridStr[i,k]:=MainStr[i];
          if (DataMod.Variable[i,k-1]>=0) and PosValues[i] then
          begin
            MainStr[i]:=FloatToStr(DataMod.Variable[i,k-1]);
            GridStr[i,k]:=MainStr[i];
            if Length(MainStr[i])<10 then
               MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
            while length(MainStr[i])<11 do
            begin
              MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
              MainStr[i]:=ConCat(' ',DataMod.MainStr[i]);
            end;
          end;
          if length(MainStr[i])>11 then delete (MainStr[i],10,1);
          if length(MainStr[i])>10 then delete (MainStr[i],10,1);
        end;

        if (i=5) and (GroupSign='Dw') then
        begin
          MainStr[i]:=FloatToStr(DataMod.Variable[i,k-1]);
          GridStr[i,k]:=MainStr[i];
          if Length(MainStr[i])<10 then
             MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
          while length(MainStr[i])<11 do
          begin
            MainStr[i]:=ConCat(DataMod.MainStr[i],' ');
            MainStr[i]:=ConCat(' ',DataMod.MainStr[i]);
          end;
          if length(MainStr[i])>11 then delete (MainStr[i],10,1);
          if length(MainStr[i])>10 then delete (MainStr[i],10,1);
        end; {if (i=5) and (GroupSign='Dw') then}

        if (GroupSign='CrA') or (GroupSign='Cxf') or
           (GroupSign='LrA') or (GroupSign='RrA') or
           (GroupSign='It') then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Zs' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Gd' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Dw' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];
        if GroupSign='FfA' then if i<6 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='A' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='EaU' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Kr' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];
        if (GroupSign='CrA') or (GroupSign='Cxf') or
           (GroupSign='LrA') or (GroupSign='RrA') or
           (GroupSign='It') then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Zs' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Gd' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='Dw' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];
        if GroupSign='FfA' then if i<6 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='A' then if i<5 then
            FileLine[k+2]:= FileLine[k+2]+MainStr[i];
        if GroupSign='EaU' then if i=6 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[6];
        if GroupSign='Kr' then if i=5 then
           FileLine[k+2]:= FileLine[k+2]+MainStr[5];

      end; {for i:= 1 to DataMod.NrOfitems do}
    end; {for k:=1 to NrOfData do}

    GroupTitle:='"Data from: '+Filename+'"';
    Output_Memo.Lines.Add(GroupTitle);
    for k:=1 to NrOfData+3 do
        Output_Memo.Lines.Add(FileLine[k-1]);
    if (GroupSign='It') then DataMod.NrOfitems := 5;
    if GroupSign='FfA' then DataMod.NrOfitems:=5;
    if (GroupSign='LrA') or (GroupSign='RrA') then DataMod.NrOfitems := 4;
    if GroupSign='Gd' then DataMod.NrOfitems:=4;
    if (GroupSign='A') then DataMod.NrOfitems := 3;
    if GroupSign='Zs' then
    begin
      DataMod.NrOfitems:=1;
      for k:=1 to DataMod.NrOfData do GridStr[1,k]:=GridStr[6,k];
    end;
    if GroupSign='Dw' then
    begin
      DataMod.NrOfitems:=1;
      for k:=1 to DataMod.NrOfData do GridStr[1,k]:=GridStr[5,k];
    end;
    if GroupSign='EaU' then
    begin
      DataMod.NrOfitems:=1;
      for k:=1 to DataMod.NrOfData do GridStr[1,k]:=GridStr[6,k];
    end;
    if GroupSign='Kr' then
    begin
      DataMod.NrOfitems:=1;
      for k:=1 to DataMod.NrOfData do GridStr[1,k]:=GridStr[5,k];
    end;
    OutGrid.Left:=60+30*(7-NrOfItems);
    OutGrid.ColCount:=NrOfItems+1;
    OutGrid.Width:=4+61*(NrOfItems+1);
    OutGrid.RowCount:=NrOfData+1;
    OutGrid.Height:=12+24*(NrOfData+1);
    if OutGrid.Height>356 then OutGrid.Height:=356;
    YearNumber:=0;
    for k:=1 to DataMod.NrOfData do
    begin
      SeasonNr:=SeasonNr+1;
      if SeasonNr>Ns then
      begin
        YearNumber:=YearNumber+1;
        SeasonNr:=1;
      end;
      OutGrid.Cells[0,k]:=inttostr(YearNumber-1);
//      OutGrid.Cells[1,k]:=inttostr(SeasonNr);
      for i:= 1 to DataMod.NrOfitems do
      begin
        OutGrid.Cells[i,k]:=GridStr[i,k];
        if GridStr[i,k]='' then OutGrid.Cells[i,k]:='  -';
      end;
    end; {for k:=1 to DataMod.NrOfData do}

    GrTitle1 := FileLine[0];
    GrTitle2 := FileLine[1];
    GrTitle3 := FileLine[2];
  end; {with DataMod do}
  OutGrid.Visible:=true;
  ClipMemo.Visible:=true;
  ClipButton.Visible:=true;
  Output_Memo.Show;
end; {TMainForm.ShowOutputGroup}
{------------------------------}


procedure TMainForm.GroupSave_Execute (Sender: TObject);
{------------------------------------------------------}
label 1;
var OutputFile : string;
    Count, k   : byte;
begin Inherited;
   Statustext ('Group data are saved as *.PRN files for spreadsheet use');
   OutputFile:=DataMod.FileName;
   with DataMod do
   begin
1:   if (SetAndVerifyGroupName) and not NoSave then
      begin
         if RadioButton13.Checked then
         begin
           WriteOutputLines (FileName);
         end else WriteOutputGroup (FileName);
      end else
      begin
        Showmessage ('The group data were not saved');
        exit;
      end;
      Count:=0;
      for k:=1 to length(DataMod.FileName) do
        if DataMod.FileName[k]='.' then Count:=Count+1;
      if Count>1 then
      begin
        Showmessage ('The number of dots (.) in the file name'+
                     ' should not be greater than 1. Please adjust.');
        DataMod.FileName:='';
        goto 1;
      end;
      ShowMessage ('The group data are saved in ' + FileName);
   end; {with DataMod do}
   DataMod.FileName:=OutputFile;
end; {TMainForm.GroupSave_Execute}
{--------------------------------}



procedure TMainForm.CloseOutput_ButtonClick(Sender: TObject);
{-----------------------------------------------------------}
begin
  inherited;
  DataMod.MonthNr:=0;
  DataMod.EndOfCalc:=false;
  Input_Tabsheet.Show;
end;{TMainForm.CloseOutput_ButtonClick}
{-------------------------------------}



procedure TMainForm.ViewGraph_ButtonClick(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  GroupOpened := true;
  SaltImage2.Visible := false;
  if not AllZero then Graphics_Tabsheet.Show;
  if AllZero then Output_Tabsheet.Show;
  AllZero:=false;
end; {TMainForm.ViewGraphButtonClick}
{-----------------------------------}



procedure TMainForm.ClipButtonClick(Sender: TObject);
const
  TAB = #9;
  CR = #13;
var
  {i, k,}  R, C: integer;
  S: string;
begin
  inherited;
(*
//Het volgende kopieert een met shift+arrows geselecteerde range
S:= '';
With OutGrid do
for i:= Selection.Top to Selection.Bottom do begin
for k:= Selection.Left to Selection.Right Do begin
S:= S + Cells[k,i];
If k <>Selection.Right Then
S := S + #9;
end;
S:= S + #13#10;
end;
Clipboard.AsText := S;
*)
//Het volgende selecteert en kopieert alles
  S := '';
  for R := 0 to OutGrid.RowCount - 1 do begin
    for C := 0 to OutGrid.ColCount - 1 do begin
      S := S + OutGrid.Cells[C, R];
      if C < OutGrid.ColCount - 1 then S := S + TAB;
    end;
    if R < OutGrid.RowCount - 1 then S := S + CR;
  end;
  Clipboard.AsText := S;
  showmessage ('The data are on the clipboard to be pasted elsewhere.');
end;


{******************************************************************************
 End of Output tabsheet, start of Graphics Tabsheet
*******************************************************************************}


procedure TMainForm.Graphics_TabSheetShow(Sender: TObject);
{---------------------------------------------------------}
begin
  inherited;
  InputSave.Enabled := false;
  Statustext ('Graphics presentations of output data can be seen and saved.'+
              ' Use "Output file" to open an output file and make graphs.');
  if GroupOpened then
  begin
    SaltImage2.Visible := false;
    GraphOpened := true;
    ShowGraphics;
  end else
  begin
    GraphImage.Visible := false;
    SaveGraph_Button.Enabled := false;
    ShowSymbolsButton.Enabled := false;
    SaltImage2.Visible := true;
  end;
end; {TMainForm.Graphics_TabSheetShow}
{------------------------------------}



procedure TMainForm.ShowGraphics;
{--------------------------------}
var Count, ii, jj, kk, Score : integer;
    DumReal : real; NameStr  : string;
    ScalarY, DecimalY, PosY3 : integer;
    MaximY, MinimY           : longint;
    HlpInt, NrOfObjects      : integer;
begin
  GraphSave.Enabled := true;
  AllZero:=false;
  if ((DataMod.GroupMark='Zs') or (DataMod.GroupMark='EaU')) and
  not PosValues[6] then
  begin
    AllZero:=true;
    Showmessage ('Only zero data present. Graph is not made');
//    Output_Tabsheet.Show;
    exit;
  end;
  MaxMin;
  Scaling;
  Relative;
  With GraphImage.Canvas do with DataMod do
  begin
    Brush.Color := clWhite;
    FillRect(GraphImage.Canvas.ClipRect);
    Font.Style := [fsBold];
    Font.Color := clTeal;      {for the titles}
    if GroupMark<>'Dw' then
    begin
      Textout (120,15,GrTitle1);
      Textout (120,30,GrTitle2);
    end else
    begin
      Textout (120,10,GrTitle1);
      Textout (120,25,GrTitle2);
    end;
    Brush.Color := $00f5fffa;
    Font.Color := clMaroon;     {for the text}
    Pen.Color := clBlue;        {for the lines}

    MaximY:=0;
    MinimY:=1000000;
    ScalarY := 10;
    DecimalY := 1;
    if (GroupMark='CrA') or (GroupMark='Cxf') or
       (GroupMark='LrA') or (GroupMark='RrA') or
       (GroupMark='It') then
    begin
       Count:=0;
       for ii:=1 to NrOfitems do if PosValues[ii] then
       begin
         Count:=Count+1;
         if MaximY<MaxY[ii] then
         begin
           MaximY:=MaxY[ii];
           ScalarY:=ScaleY[ii];
           DecimalY:=DecimY[ii];
         end;
         if MinimY>MinY[ii] then
            MinimY:=MinY[ii];
       end;
       AllZero:=false;
       if Count=0 then
       begin
         AllZero:=true;
         Showmessage ('Only zero data present. Graph is not made');
         exit;
       end;
    end;

    if (GroupMark='FfA') or (GroupMark='A') then
    begin
      Count:=0;
      for ii:=1 to NrOfitems-1 do if PosValues[ii] then
          Count:=Count+1;
      if Count=0 then
      begin
        Showmessage ('Only zero data present. Graph is not made');
        Output_Tabsheet.Show;
        exit;
      end;
      MaximY:=120;
      MinimY:=0;
      ScalarY:=6;
    end;

    if (GroupMark='Zs') or (GroupMark='EaU') then
    begin
      MaximY:=MaxY[6];
      MinimY:=MinY[6];
      ScalarY:=ScaleY[6];
      DecimalY:=DecimY[6];
    end; {if (GroupMark='Zs') or (GroupMark='EaU') then}

    if (GroupMark='Gd') then
    begin
      Count:=0;
      for ii:=1 to 4 do if PosValues[ii] then
      begin
         Count:=Count+1;
         if MaximY<MaxY[ii] then
         begin
           MaximY:=MaxY[ii];
           ScalarY:=ScaleY[ii];
           DecimalY:=DecimY[ii];
         end;
         if MinimY>MinY[ii] then
            MinimY:=MinY[ii];
      end;
      AllZero:=false;
      if Count=0 then
      begin
         AllZero:=true;
         Showmessage ('Only zero data present. Graph is not made');
        exit;
      end;
    end;{ if (GroupMark='Gd') or (GroupMark='A') then }

    if (GroupMark='Dw') then
    begin
      MaximY:=MaxY[5];
      MinimY:=MinY[5];
      ScalarY:=ScaleY[5];
      DecimalY:=DecimY[5];
    end; {if GroupMark='Dw' hen}

    HlpInt:=0;
    if (GroupMark='FfA') or (GroupMark='A') then HlpInt:=1;
    for ii:=HlpInt to ScalarY do                         { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScalarY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScalarY)*LY));
      DumReal := ii/ScalarY*(MaximY-MinimY);
      NameStr := format('%' + IntToStr(2 + DecimalY) + '.' +
                 IntToStr(DecimalY) + 'f', [MaximY - DumReal]);
          {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      if ii<ScalarY then
         Textout ((posX1-TextWidth(NameStr)-6),
         (round(posY1+(ii/ScalarY)*LY)-round(1/2*TextHeight(NameStr))),
                                                            NameStr);
      if (GroupMark='Dw') and (ii=ScalarY) then
         Textout ((posX1-TextWidth(NameStr)-6),
         (round(posY1+(ii/ScalarY)*LY)-round(1/2*TextHeight(NameStr))),
                                                            NameStr);
    end; {for ii:=0 to ScalarY do}

      Count:=-1;                               {horizontal axis}
      if TimeStep='Month' then
         TextOut(625,PosY2+25,'Month');
      if TimeStep='Week' then
         TextOut(625,PosY2+25,'Week');
      if TimeStep='Day' then
         TextOut(625,PosY2+25,'Day');
      HlpInt := round (LX*(Xcount[1]-MinX)/(MaxX-MinX));
      RelXdata[0] := PosX1+round(HlpInt);
      for jj:= 0 to Nm-1 do
        for ii:=1 to Ns do
        begin
          Count:=Count+1;
          if ii=Ns then
          begin
            TextOut (RelXdata[Count]-5,PosY2+10,IntToStr(jj+1));
            Moveto (RelXdata[Count], PosY2);
            Lineto (RelXdata[Count], PosY2+6);
          end else
          begin
            Moveto (RelXdata[Count],PosY2);
            Lineto (RelXdata[Count],PosY2+4);
          end;
        end; {for jj:= 0 to Nm-1 do for ii:=1 to Ns do}

    if (GroupMark='CrA') or (GroupMark='Cxf') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='CrA' then
      TextOut (PosX1+10,PosY1-15,'Soil salinity, EC in dS/m');
      if GroupMark='Cxf' then
      TextOut (PosX1+10,PosY1-15,'Other salinities, EC in dS/m');
      Font.Style := [];
      if GroupMark='CrA' then
      TextOut (300,45,'Only applicable values are shown')
      else
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the value of drainage key Kd');

      Font.Style:= [fsBold];
      Pen.Width := 2;
      for ii:=1 to NrOfitems do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrA*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxf*100');
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrB*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CxA*100');
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'CrU*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cxb*100');
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clLime;
          Font.Color:= clLime;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cr4*100');
          end;
          if GroupMark='Cxf' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cqf*100');
          end;
        end;
        if ii=5 then
        begin
          Pen.Color := clSilver;
          Font.Color:= clSilver;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1A*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C1*100');
          end;
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Ci*100');
        end;
        if ii=6 then
        begin
          Pen.Color := clFuchsia;
          Font.Color:= clFuchsia;
          if GroupMark='CrA' then
          begin
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C2*100');
          end;
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cd*100');
        end;
        if ii=7 then
        begin
          Pen.Color := $008AD5FD;
          Font.Color:= $008AD5FD;
          if GroupMark='CrA' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'C3*100');
          if GroupMark='Cxf' then
             if FactorY[ii]=1 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw')
             else
             if FactorY[ii]=10 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw*10')
             else
             if FactorY[ii]=100 then
                TextOut (PosX1+15+50*(Score-1),PosY1,'Cw*100');
        end;
        if (GroupMark<>'Cxf') or ((GroupMark='Cxf') and (ii<5)) then
        for jj:=1 to Nm-1 do
            for kk:=1 to Ns do
            begin
              Count:=Count+1;
              if (Count>0) and (Count<NrOfData) then
              begin
                Moveto (RelXdata[Count-1],RelYdata[ii,Count-1]);
                Lineto (RelXdata[Count],RelYdata[ii,Count]);
              end;
            end;
        if ((GroupMark='Cxf') and (ii>4)) then
        for jj:=1 to Nm-1 do
            for kk:=1 to Ns do
            begin
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1],RelYdata[ii,Count]);
                Lineto (RelXdata[Count],RelYdata[ii,Count]);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Width := 1;
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='CrA') or (GroupMark='Cxf') then}

    if (GroupMark='Zs') then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      Count:=0;
      TextOut (PosX1+10,PosY1-15,'Salt storage Zs in m.dS/m');
      if FactorY[6]=1 then
         TextOut (PosX1+15,PosY1,'Zs')
      else
      if FactorY[6]=10 then
         TextOut (PosX1+15,PosY1,'Zs*10')
      else
      if FactorY[6]=100 then
         TextOut (PosX1+15,PosY1,'Zs*100');
      for jj:=1 to Nm-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if (Count<NrOfData) then
            begin
              Moveto (RelXdata[Count-1],RelYdata[6,Count-1]);
              Lineto (RelXdata[Count],RelYdata[6,Count]);
            end;
          end;
      Font.Color := clMaroon;     {for the text}
    end;{if GroupMark='Zs' then}

    if (GroupMark='Gd') or (GroupMark='A') then
    begin
      if (GroupMark='Gd') then
         TextOut (PosX1+10,PosY1-15,'Drain/well discharge (m/timestep)');
      if (GroupMark='A') then
         TextOut (PosX1+10,PosY1-15,'Area fractions (%)');

      Font.Style := [];
      TextOut (293,45,'Only applicable values are shown depending'+
                      ' on the parameter values employed');
      Font.Style:= [fsBold];
      Score:=0;
      for ii:=1 to 4 do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gd')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gd*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'A');
        end;
        if ii=2 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Ga')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Ga*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'B');
        end;
        if ii=3 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gb')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gb*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'U');
       end;
        if ii=4 then
        begin
          Pen.Color := $008AD5FD;
          Font.Color:= $008AD5FD;
          if GroupMark='Gd' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Gw')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Gw*'+NameStr);
            end;
          end else
              TextOut (PosX1+15+50*(Score-1),PosY1,'Uc');
        end;
        for jj:=1 to Nm-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto (RelXdata[Count-1]+HlpInt,
                        RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,
                        RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end;{for ii:=1 to 4 do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end;{ if (GroupMark='Gd') or (GroupMark='A') then }

    if (GroupMark='Dw') then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      TextOut (PosX1+10,PosY1-25,'');
      if FactorY[5]=1 then
         TextOut (PosX1+10,PosY1-20,'Water level relative to soil surface')
      else
      begin
        NameStr:=IntToStr(FactorY[5]);
        TextOut (PosX1+10,PosY1-20,'LWT *'+NameStr);
      end;

      if Ymax[5]<=0 then
      BEGIN
      Count:=-1;
      for jj:=0 to Nm-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if kk=1 then Brush.Color := clMoneyGreen;
            if kk=2 then Brush.Color := clSilver;
            if kk=3 then Brush.Color := clYellow;
            if kk=4 then Brush.Color := clRed;
            if Count=0 then
                 Fillrect (Rect(PosX1,PosY1,RelXdata[Count]-1,
                           RelYdata[5,Count]+2));
            if (Count>0) and (Count<DataMod.NrOfData) then
            begin
              if Variable[5,Count]<=0 then
                 Fillrect (Rect(RelXdata[Count-1],PosY1,RelXdata[Count]-1,
                           RelYdata[5,Count]+2))
              else
                 Fillrect (Rect(RelXdata[Count-1],RelYdata[5,Count],
                           RelXdata[Count]-2,PosY1+2));
            end;
          end;
      END;
      if Ymax[5]>0 then
      BEGIN
        Count:=-1;
        PosY3:=(PosY1+PosY2) div 2;
        for jj:=0 to Nm-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if kk=1 then Brush.Color := clMoneyGreen;
            if kk=2 then Brush.Color := clSilver;
            if kk=3 then Brush.Color := clYellow;
            if kk=4 then Brush.Color := clRed;
            if Count=0 then
                 Fillrect (Rect(PosX1,PosY3,RelXdata[Count]-1,
                           RelYdata[5,Count]+2));
            if (Count>0) and (Count<DataMod.NrOfData) then
            begin
              if Variable[5,Count]<=0 then
                 Fillrect (Rect(RelXdata[Count-1],PosY3,RelXdata[Count]-1,
                           RelYdata[5,Count]+2))
              else
                 Fillrect (Rect(RelXdata[Count-1],RelYdata[5,Count],
                           RelXdata[Count]-2,PosY3+2));
            end;
          end;
        END;

      Brush.Color := $00f5fffa;
      Font.Color := clMaroon;     {for the text}
      Pen.Color := clBlue;
    end;{if (GroupMark='Dw') then }

    if (GroupMark='LrA') or (GroupMark='RrA') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='LrA' then
      TextOut (PosX1+10,PosY1-15,'Pecolation in m/timestep');
      if GroupMark='RrA' then
      TextOut (PosX1+10,PosY1-15,'Capillary rise in m/timestep');
      Font.Style := [];
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the parameter values given');
      Font.Style:= [fsBold];
      for ii:=1 to NrOfitems do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clBlue;
          Font.Color := clBlue;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrA*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrA*'+NameStr);
            end;
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clGreen;
          Font.Color:= clGreen;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrB*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrB*'+NameStr);
            end;
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrU')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrU*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrU')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrU*'+NameStr);
            end;
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clLime;
          Font.Color:= clLime;
          if GroupMark='LrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'LrAve')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'LrAve*'+NameStr);
            end;
          end;
          if GroupMark='RrA' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'RrAve')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'RrAve*'+NameStr);
            end;
          end;
        end;
        for jj:=1 to Nm-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='LrA') or (GroupMark='RrA') then}

    if (GroupMark='It') or (GroupMark='FfA') then
    begin
      Score:=0;                                   {plotting of lines}
      if GroupMark='It' then
         TextOut (PosX1+10,PosY1-15,'Irrigation data in m/timestep')
      else
         TextOut (PosX1+10,PosY1-15,'Efficiency/sufficiency in %');
      Font.Style := [];
      TextOut (300,45,'Only applicable values are shown depending'+
                      ' on the parameter values given');
      Font.Style:= [fsBold];
      NrOfObjects:=NrOfItems;
      if GroupMark='FfA' then NrOfObjects:=5;
      for ii:=1 to NrOfObjects do if PosValues[ii] then
      begin
        Count:=0;
        Score:=Score+1;
        if ii=1 then
        begin
          Pen.Color := clGreen;
          Font.Color := clGreen;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'It')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'It*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfA*'+NameStr);
            end;
          end;
        end;
        if ii=2 then
        begin
          Pen.Color := clFuchsia;
          Font.Color:= clFuchsia;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Is')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Is*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfB*'+NameStr);
            end;
          end;
        end;
        if ii=3 then
        begin
          Pen.Color := clRed;
          Font.Color:= clRed;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'Io')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'Io*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'FfT')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'FfT*'+NameStr);
            end;
          end;
        end;
        if ii=4 then
        begin
          Pen.Color := clBlue;
          Font.Color:= clBlue;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'IaA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'IaA*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'JsA')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'JsA*'+NameStr);
            end;
          end;
        end;
        if ii=5 then
        begin
          Pen.Color := clMaroon;
          Font.Color:= clMaroon;
          if GroupMark='It' then
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'IaB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'IaB*'+NameStr);
            end;
          end else
          begin
            if FactorY[ii]=1 then
               TextOut (PosX1+15+50*(Score-1),PosY1,'JsB')
            else
            begin
              NameStr:=IntToStr(FactorY[ii]);
              TextOut (PosX1+15+50*(Score-1),PosY1,'JsB*'+NameStr);
            end;
          end;
        end;
        for jj:=1 to Nm-1 do
            for kk:=1 to Ns do
            begin
              HlpInt:=ii-1;
              if ii=1 then HlpInt:=ii-2;
              Count:=Count+1;
              if (Count<NrOfData) then
              begin
                Moveto(RelXdata[Count-1]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
                Lineto (RelXdata[Count]+HlpInt,RelYdata[ii,Count]-2*HlpInt);
              end;
            end;
      end; {for ii:=1 to NrOfitems do if PosValues[ii] then}
      Pen.Color := clBlue;
      Font.Color := clMaroon;     {for the text}
    end; {if (GroupMark='It') or (GroupMark='FfA') then}

    if GroupMark='EaU' then
    begin
      Pen.Color := clNavy;
      Font.Color:= clNavy;
      Count:=0;
      TextOut (PosX1+10,PosY1-15,'Actual evaporation from unirrigated land'+
                                 ', m/timestep');
      if FactorY[6]=1 then
         TextOut (PosX1+15,PosY1,'EaU')
      else
      if FactorY[6]=10 then
         TextOut (PosX1+15,PosY1,'EaU*10')
      else
      if FactorY[6]=100 then
         TextOut (PosX1+15,PosY1,'EaU*100');
      for jj:=1 to Nm-1 do
          for kk:=1 to Ns do
          begin
            Count:=Count+1;
            if (Count<NrOfData) then
            begin
              Moveto(RelXdata[Count-1],RelYdata[6,Count]);
              Lineto (RelXdata[Count],RelYdata[6,Count]);
            end;
         end;
      Font.Color := clMaroon;     {for the text}
    end;{if GroupMark='EaU' then}

    moveto (PosX1,PosY2+4);                         {Axis lines}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);
    TextOut (70,PosY2+45,'SaltMod: ' + FileName);

  end; {with GraphImage.canvas do with DataMod do}
  GraphOpened:=true;
  GraphImage.Visible:=true;
  SaveGraph_Button.Enabled:=true;
  ShowSymbolsButton.Enabled:=true;
end; {TMainForm.ShowGraphics}
{---------------------------}



procedure TMainForm.SetInitialDir (AuxDir:string);
{------------------------------------------------}
begin
  MainForm.InputOpen_Dialog.InitialDir:=AuxDir;
  MainForm.InputSave_Dialog.InitialDir:=AuxDir;
  MainForm.OutputOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GraphOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GraphSave_Dialog.InitialDir:=AuxDir;
  MainForm.GroupOpen_Dialog.InitialDir:=AuxDir;
  MainForm.GroupSave_Dialog.InitialDir:=AuxDir;
end; {TMainForm.SetInitialDir}
{----------------------------}




procedure TMainForm.ShowSymbolsButtonClick(Sender: TObject);
begin
  inherited;
  OutputSymbolsForm.Show;
end;



procedure TMainForm.Cancel_ButtonClick(Sender: TObject);
begin
  inherited;
  Panel1.Hide;
end;


{******************************************************************************
 End of Graphics tabsheet, start of CloseForm,
 ******************************************************************************}


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin Inherited;
      Action := caNone;
      CloseForm.Show;
end; {TMainForm.FormClose}



procedure TMainForm.FormShow(Sender: TObject);
begin Inherited;
      If CloseForm.Visible then
            Application.Terminate;
end; {TMainForm.FormShow}


{******************************************************************************
 End of CloseForm, start of MENU ITEMS
 ******************************************************************************}

{Action FileOpen}

procedure TMainForm.InputOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var InputDir : string;
begin Inherited;
  with DataMod do
  begin
      if MainForm.InputOpen_Dialog.Execute then
      begin
        Filename := MainForm.InputOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
        begin
          ReadInputFile;
          while Pos(' ',TimeStep)>0 do delete(TimeStep,Pos(' ',TimeStep),1);
          if TimeStep='Month' then TimeStepCombo.ItemIndex:=0;
          if TimeStep='Week' then TimeStepCombo.ItemIndex:=1;
          if TimeStep='Day' then TimeStepCombo.ItemIndex:=2;
          MakeStrings;
          YI:=0;          //Required after a discontinued previous run with
                         //monthly calculations
          MonthNr:=0;   //Same
          FirstMonth:=true;
          if TimeStep='Month' then TimeStepCombo.ItemIndex:=0;
          if TimeStep='Week' then TimeStepCombo.ItemIndex:=1;
          if TimeStep='Day' then TimeStepCombo.ItemIndex:=2;
        end else
        begin
           Showmessage ('File does not exist, please select another one,');
           exit;
        end;
      end
      else
      begin
        ShowMessage('No input file was selected');
        exit;
      end;
      WarningForm.Visible:=false;
      FilenameLabel.Caption := FileName;
      FilenameLabel.Show;
      FileName_Label.Show;
      StatusText('Edit the data.  Then use "Save/run", after which'+
                 ' calculations will be done.');
      Title1_Edit.Text:=Title1;
      Title2_Edit.Text:=Title2;
  end; {with DataMod do}
  InputDir:=Getcurrentdir;
  SetInitialDir (InputDir);
  InputSave.Enabled := true;
  InputOpened := true;
end; {TMainForm.InputOpen_Execute}
{--------------------------------}



procedure TMainForm.InputSave_Execute (Sender: TObject);
{------------------------------------------------------}
label 1;
var DataOK, Result : boolean;
    TmpTxt         : textfile;
    Count, k       : byte;

begin Inherited;
   with DataMod do
   begin
1:   if (SetAndVerifySaveName) and not NoSave then
     begin
       Title1 := Title1_Edit.Text;
       Title2 := Title2_Edit.Text;
       DecimalSeparator := InitDecSep;
       MakeValues;
       CheckData(DataOK);
       if not DataOK then exit;
     end
     else
     begin
       Showmessage ('The input data were not saved');
       exit;
     end;
     if not FileExists (FileName) then
     begin
       AssignFile (TmpTxt,FileName);
       rewrite (TmpTxt);
       CloseFile (TmpTxt);
     end;

     DataFile := ExtractFileName (FileName);
     Count:=0;
     for k:=1 to length(DataFile) do
       if DataFile[k]='.' then Count:=Count+1;
     if Count>1 then
     begin
       Showmessage ('The number of dots (.) in the file name'+
                    ' should not be greater than 1. Please adjust.');
       goto 1;
     end;
     WarningForm.Visible:=false;
     if DataMod.MonthNr<2 then DataMod.OriginalName:=FileName;
     DataDir := getcurrentdir;
     if DataMod.MonthNr<2 then OriginalDir:=DataDir;
     NewDir := ExtractFilePath(FileName);
     OldDir := ExtractFilePath(OriginalName);
     if (OriginalName<>FileName) and (MonthNr>1) then
        if  NewDir<>OldDir then
        begin
           Deletefile (FileName);
           Showmessage (' During calculations with input changes,'+
                        ' the data-path cannot be changed. Please save the'+
                        ' input file in  '+OldDir);
           InputSave_Dialog.InitialDir:=OldDir;
//This does not work, it is difficult to set initialdir effectively
           goto 1;
         end;
     DataDir := getcurrentdir;
     SetInitialDir (DataDir);
     chdir(InitDir);
     EndOfCalc := false;
     if FirstMonth then
     begin
       First:=1;
       MonthNr:=1;
       FirstMonth:=false;
       PermanentFile:=FileName;
     end;
     WriteInputFile(FileName);
     WaitMemo.Visible:=true;
     WaitMemo.Lines.Clear;
     WaitMemo.Lines.Add(' Saving the data');
     sleep(500);
     Result := Question('The data were saved in: '+Filename+'. Do you wish'+
                        ' to do the calculations?');
     if not Result then
     begin
       WaitMemo.Lines.Clear;
       WaitMemo.Visible:=false;
       exit;
     end;
     DoCalculations;
     if RuntimeError then exit;
     WaitMemo.Lines.Add(' Finalizing ......');
     Sleep(500);
     WaitMemo.Visible:=false;
     if not WTdepth then MonthlyMessages;
     if RunTimeWarning then with DataMod do
     begin
       showmessage ('One or more runtime warnings are given.');
       WarningForm.Visible:=true;
     end;
   end; {with DataMod do}
   if DataMod.EndOfCalc then
   begin
     OutputOpened:=true;
     SaveGroupButton.Visible := false;
     ViewGraph_Button.Visible := false;
     Output_Tabsheet.Show;
   end;
   if WTdepth then if not DataMod.EndOfCalc then
   begin
     OutputOpened:=true;
     SaveGroupButton.Visible := false;
     ViewGraph_Button.Visible := false;
     Output_Tabsheet.Show;
   end;

end; {TMainForm.InputSave_Execute}
{--------------------------------}



procedure TMainForm.OutputOpen_Execute(Sender: TObject);
{------------------------------------------------------}
var k : integer;
    ReadingOK : boolean;
begin
  inherited;
    Output_Memo.Visible:=false;
    Panel1.Hide;
    SaveGroupButton.Visible := false;
    ViewGraph_Button.Visible := false;
    with DataMod do
    begin
      if MainForm.OutputOpen_Dialog.Execute then
      begin
        Filename := MainForm.OutputOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
           ReadOutputLines(Filename,ReadingOK)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No output file was selected');
        OutputOpened:=false;
        exit;
      end;
      StatusText ('Click "Output group" or "Group file" to see graphs.'+
                  ' Alternatively click "Output file" to open an output file' +
                  ' to make graphs.');
      Output_Memo.Lines.Clear;
      for k:=1 to DataMod.NrOfLines do
          Output_Memo.Lines.Add(FileLine[k-1]);
    end; {with DataMod do}
    Output_Memo.Visible:=true;
    OutputOpened := true;
    GroupOpenButton.Visible:=true;
    CloseOutput_Button.Visible:=true;
    OutputSymbols_Button.Visible:=true;
    Group_Button.Visible := true;
    Group_Button.Enabled := true;
    ViewGraph_Button.Visible := false;
    SaltImage1.Visible := false;
    GroupOpened:=false;
    WarningForm.Visible:=false;
    OutGrid.Visible:=false;
    ClipMemo.Visible:=false;
    ClipButton.Visible:=false;
    DataDir:=Getcurrentdir;
    SetInitialDir (DataDir);
    Output_Memo.Height:=424;
    Output_Tabsheet.Show;
end; {TMainForm.OutputOpen_Execute}
{---------------------------------}



procedure TMainForm.GroupOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var i,k : integer;
    ReadingOK : boolean;
begin
  inherited;
      if MainForm.GroupOpen_Dialog.Execute then  with DataMod do
      begin
        Filename := MainForm.GroupOpen_Dialog.Files.Strings[0];
        if FileExists (Filename) then
        begin
          Output_Memo.Hide;
          ReadOutputLines (FileName,ReadingOK);
          Output_Memo.Lines.Clear;
          for k:=1 to DataMod.NrOfLines do
          begin
            Output_Memo.Lines.Add(FileLine[k-1]);
          end;
          Output_Memo.Show;
          ReadGroupData;
          if DataMod.GroupNotRead then
          begin
            OutputOpened:=false;
            GroupNotRead:=false;
            Output_Tabsheet.Show;
            DataMod.GroupNotRead:=false;
            ViewGraph_Button.Visible := false;
            SaveGroupButton.Visible := false;
            Group_Button.Visible    := false;
            exit;
          end;
          for i:=1 to 7 do PosValues[i]:=false;
          for i:=1 to NrOfitems do for k:=0 to NrOfData-1 do
              if Variable[i,k]>0 then PosValues[i]:=true;
          if GroupMark='Dw' then
          begin
             for k:=0 to NrOfData-1 do
             begin
               setlength (Variable[5],k+1);
               Variable[5,k]:=Variable[1,k];
             end;
             PosValues[5]:=true;
          end;
          ViewGraph_Button.Enabled := true;
          ViewGraph_Button.Visible := true;
          SaveGroupButton.Visible := true;
          Group_Button.Visible    := true;
          Group_Button.Enabled    := false;
        end
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No output group was selected');
        exit;
      end;
      CloseOutput_Button.Visible:=true;
      OutputSymbols_Button.Visible:=true;
      OutputOpened:=true;
      Output_Tabsheet.Show;
end; {TMainForm.GroupOpen_Execute}
{--------------------------------}



procedure TMainForm.GraphOpen_Execute(Sender: TObject);
{-----------------------------------------------------}
var FigureFile:string;
begin
  inherited;
      GraphOpened := true;
      if MainForm.GraphOpen_Dialog.Execute then  with DataMod do
      begin
        FigureFile := MainForm.GraphOpen_Dialog.Files.Strings[0];
        if FileExists (FigureFile) then
          GraphImage.Picture.LoadFromFile(FigureFile)
        else
        begin
          Showmessage ('File does not exist, please select another one,');
          exit;
        end;
      end
      else
      begin
        Showmessage('No image file was selected');
        exit;
      end;
      Graphics_Tabsheet.Show;
end; {TMainForm.GraphOpen_Execute}
{--------------------------------}



procedure TMainForm.GraphSave_Execute(Sender: TObject);
{-----------------------------------------------------}
label 1;
var Result : boolean;
    OutputFile : string;
    Count, k   : byte;
begin
  inherited;
    OutputFile:=DataMod.FileName;
1:    if GraphSave_Dialog.Execute then with DataMod do
      begin FileName := GraphSave_Dialog.Files.Strings[0];
        if FileExists(FileName) then
             Result := Question('The file already exists, overwrite?')
        else Result := true;
        if Result then
        begin
          Count:=0;
          for k:=1 to length(DataMod.FileName) do
              if DataMod.FileName[k]='.' then Count:=Count+1;
          if Count>1 then
          begin
            Showmessage ('The number of dots (.) in the file name'+
                         ' should not be greater than 1. Please adjust.');
            DataMod.FileName:='';
            goto 1;
          end;
          GraphImage.Picture.SaveToFile(FileName);
          Showmessage ('The graph was saved in  ' + Filename);
        end;
      end
      else Showmessage ('The graph was not saved');
    DataMod.FileName:=OutputFile;
end; {TMainForm.GraphSave_Execute}
{--------------------------------}


//werkt niet goed
procedure TMainForm.FilePrint_Execute(Sender: TObject);
begin
  ShellExecute(Handle,'Print','DataMod.FileName',nil,nil,sw_shownormal);
end;



end.






